package cat.pepweb.pep;



import cat.pepweb.pep.serveis.ServeiCercarTrajectes;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class Cerca extends Activity {

	private static Cerca cercar;
	private EditText origen;
	private EditText destinacio;
	private EditText data;
	public static Button enviar;
	private Button tornar;



	public static Cerca getInstance(){ //Per els toast
		return cercar;
	}

	/** Called when the activity is first created. */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.cercar_trajecte);
		cercar = this;

		origen = (EditText)findViewById(R.id.origen_cerca);
		destinacio = (EditText) findViewById(R.id.destinacio_cerca);
		data = (EditText) findViewById(R.id.data_cerca);
		tornar = (Button) findViewById(R.id.tornar_cerca);
		enviar = (Button) findViewById(R.id.enviar_cerca);

		//Capturem i tractem la pulsaci del bot enviar cerca.

		enviar.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//enviar.setBackgroundColor(Color.rgb(153, 204, 0));
				enviarCerca(view); //Cridem el mtode que gestiona l'acci.

			}
		});

		//Capturem i tractem la pulsaci del bot tornar a opcions.

		tornar.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//tornar.setBackgroundColor(Color.rgb(153, 204, 0));
				tornarOpcions(view); //Cridem el mtode que gestiona l'acci.
			}
		});

	}
	/**
	 * Mtode per cercar trajecte comprovant els parmetres d'entrada.
	 * @param view
	 */
	private void enviarCerca(View view){

		String data1="";
		String origen1 = "";
		String destinacio1 = "";
		boolean ok = true;
		//Log.e("data1: ", data1.toString());
		//Recuperem la informaci per a fer la cerca.

		origen1 =(origen.getText().toString());

		destinacio1 = (destinacio.getText().toString());

		data1= (data.getText().toString());


		//Canviem els espais en blanc per "%20".
		if(!((origen1.equals("")) || (destinacio1.equals("")))){
			String origen2;
			String destinacio2;
			origen2 = origen1.replace(" ", "%20");
			destinacio2 = destinacio1.replace(" ", "%20");

			//Formatem l'origen i dest a primera lletra majscula i resta minscules.
			String origen3 = origen2.substring(0, 1).toUpperCase()+
					origen2.substring(1).toLowerCase();
			String destinacio3 = destinacio2.substring(0, 1).toUpperCase()+
					destinacio2.substring(1).toLowerCase();

			if(!(data.length()==0)){

				String dia="";
				String separador1="";
				String mes="";
				String separador2="";
				String any1="";
				String any2="";
				String any3="";
				String any4="";
				int dia3 = 0;
				int mes3 = 0;
				//Carreguem la data  per comprovar el format.
				try{
					dia = data1.substring(0, 2);
					separador1 = data1.substring(2, 3);
					mes = data1.substring(3, 5);
					separador2 = data1.substring(2, 3);
					any1 = data1.substring(6, 7);
					any2 = data1.substring(7, 8);
					any3 = data1.substring(8, 9);
					any4 = data1.substring(9);
				}catch(Exception e){
					ok = false;
					//Notifiquem a l'usuari que la data t un format incorrecte.
					Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
							"El format de la data no s (dd/mm/yyyy)" ,
							Toast.LENGTH_SHORT).show();
					//enviar.setBackgroundColor(Color.rgb(6, 227, 62));
					Log.e("data: ", data1);
				}
				//Comprovem que la data est ben formatada.
				if(ok == true){
					try{
						dia3 = Integer.parseInt(dia);
						mes3 = Integer.parseInt(mes);
						Integer.parseInt(any1);
						Integer.parseInt(any2);
						Integer.parseInt(any3);
						Integer.parseInt(any4);

					}catch(Exception e){
						ok = false;
						//Notifiquem a l'usuari que la data t un format incorrecte.
						Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
								"El format de la data s incorrecte." ,
								Toast.LENGTH_SHORT).show();
						//enviar.setBackgroundColor(Color.rgb(6, 227, 62));

					}

					if(ok == true){
						if(!((separador1.equals("/")) && (separador2.equals("/")))){
							ok = false;
							//Notifiquem a l'usuari que la data t un format incorrecte.
							Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
									"El format de la data s incorrecte." ,
									Toast.LENGTH_SHORT).show();
							//enviar.setBackgroundColor(Color.rgb(6, 227, 62));
						}
					}

					//Comprovem que dia i mes estiguin en el rang.
					if(ok == true){
						if(dia3 == 0 || dia3 >31 || mes3 ==0 || mes3 >12){
							ok = false;

							//Notifiquem a l'usuari que el dia o el mes estan fora de rang.
							Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
									"Dia o mes fora de rang." ,
									Toast.LENGTH_SHORT).show();
							//enviar.setBackgroundColor(Color.rgb(6, 227, 62));

						}
					}
				}
			}

			if(ok == true){

				int i = ServeiCercarTrajectes.accioCercar(origen3, destinacio3, data1);//Enviem la informaci.

				//Notifiquem que l'operaci pot portar un temps.
				Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
						"Aquesta operaci pot tardar uns segons.", 
						Toast.LENGTH_SHORT).show();


			}
		}else{
			//Informem a l'usuari que els camps origen i destinaci sn obligatoris.
			Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
					"Els camps origen i destinaci sn obligatoris." ,
					Toast.LENGTH_SHORT).show();
			//enviar.setBackgroundColor(Color.rgb(6, 227, 62));
		}
	}
	/**
	 * Finalitcem l'activitat reinicialitzant les variables oportunes.
	 * @param view
	 */
	private void tornarOpcions(View view){

		//Opcions.cercarTrajecte.setBackgroundColor(Color.rgb(206, 217, 4));
		LlistatTrajectesCercats.llistaImatges.clear();
		LlistatTrajectesCercats.llistaTrajectes.clear();

		finish();

	}

}
