package cat.pepweb.pep;

import java.util.ArrayList;

import org.mapsforge.android.maps.MapActivity;
import org.mapsforge.android.maps.MapView;
import org.mapsforge.android.maps.mapgenerator.tiledownloader.MapnikTileDownloader;
import org.mapsforge.android.maps.overlay.ArrayItemizedOverlay;
import org.mapsforge.android.maps.overlay.ArrayWayOverlay;
import org.mapsforge.android.maps.overlay.OverlayItem;
import org.mapsforge.android.maps.overlay.OverlayWay;
import org.mapsforge.core.GeoPoint;

import cat.pepweb.pep.beans.Trajecte;
import cat.pepweb.pep.serveis.ServeiCercarPunts;

import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.widget.Toast;


public class Mapa extends MapActivity {

	public static GeoPoint centrat = new GeoPoint(42.2, 2.3);
	public static GeoPoint[][] ruta = new GeoPoint[1][];
	public static Trajecte trajecte = new Trajecte();
	private static Mapa mapa;

	public static Mapa getInstance(){ //Per els toast
		return mapa;
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		mapa = this;
		MapView mapView = new MapView(this, new MapnikTileDownloader());
		mapView.setClickable(true);//Activem interacci amb el mapa.
		mapView.setBuiltInZoomControls(true);//Activem control de zoom.
		//TrajecteCercatSeleccionat.botoMapa.setBackgroundColor(Color.rgb(120, 34, 34));
		//Preparem les dades per la consulta que ens t que tronar els punts.
		ArrayList <String> parametres = new ArrayList<String>();
		parametres.add("tasca");
		parametres.add("mapa");
		parametres.add("origen");
		parametres.add(trajecte.getOrigen());
		parametres.add("destinacio");
		parametres.add(trajecte.getDestinacio());
		//Consulta.
		int z = ServeiCercarPunts.accioCercarPunts(parametres);

		//Funcionalitat per generar ruta si la cerca ha anat b:
		if(z == 1){
			//DefaultPaintFill   wayDefaultPaintFill =    new DefaultPaintFill();
			Paint wayPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
			wayPaint.setStyle(Paint.Style.STROKE);//Tipus uni dels punts.
			wayPaint.setColor(Color.BLUE);//Color de la ruta.
			wayPaint.setAlpha(192);//Transparncia.
			wayPaint.setStrokeWidth(6);//Ample lnia
			wayPaint.setStrokeJoin(Paint.Join.MITER);
			mapView.setCenter(centrat);//Punt central en la presentaci.
			OverlayWay way = new OverlayWay(ruta);//Confecci ruta.

			//Cerquem el punt final de la ruta.
			int puntFinal = (ruta[0].length)-1;

			//Obtenim les imatges dels punts d'origen i destinaci.
			Drawable dibuix = getResources().getDrawable(R.drawable.icona_bandera1);
			//Creem l'overlay per a gestionar i emmagatzemar els punts.
			ArrayItemizedOverlay itemizedOverlay1 = new ArrayItemizedOverlay(dibuix);
			ArrayItemizedOverlay itemizedOverlay2 = new ArrayItemizedOverlay(dibuix);
			//Seleccionem els punts on s'han de collocar.
			GeoPoint puntOrigen = new GeoPoint(ruta[0][0].getLatitude(),
					ruta[0][0].getLongitude());
			GeoPoint puntDestinacio = new GeoPoint(ruta[0][puntFinal].getLatitude(),
					ruta[0][puntFinal].getLongitude());
			//Generem els punts i els hi posem el nom de l'origen i destinaci.
			OverlayItem item1 = new OverlayItem(puntOrigen, "","");
			OverlayItem item2 = new OverlayItem(puntDestinacio, "","");
			//Incloem els punts en l'overlay.
			itemizedOverlay1 .addItem(item1);
			itemizedOverlay2 .addItem(item2);
			ArrayWayOverlay wayOverlay = new ArrayWayOverlay(wayPaint,wayPaint);

			wayOverlay.addWay(way);//Afegim la ruta.
			mapView.getOverlays().add(wayOverlay);//Afegim la ruta en el mapView.
			mapView.getOverlays().add(itemizedOverlay1);//Afegim l'origen en el mapView.
			mapView.getOverlays().add(itemizedOverlay2);

			mapView.getController().setZoom(11);//Nivell de zoom en iniciar.
			setContentView(mapView);
		}else if(z == 5){
			//Notifiquem error en l'extracci de les dades.
			Toast.makeText(this.getBaseContext(),"" +
					"La ruta no est disponible.", 
					Toast.LENGTH_SHORT).show();
			finish();
		}
	}

}
