package cat.pepweb.pep;



import cat.pepweb.pep.beans.Usuari;
import cat.pepweb.pep.serveis.ServeiLlistatTrajectes;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;


public class Opcions extends Activity{

	public static Button pubTrajecte;
	public static Button llisTrajecte;
	public static Button cercarTrajecte;
	public static Button comentari;
	private Button boto_ajuda;
	private Button surtOpcions;

	private static Opcions opcions;

	public static Opcions getInstance(){
		return opcions;
	}

	/** Called when the activity is first created. */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.menu1);

		opcions = this;

		pubTrajecte = (Button) findViewById(R.id.publicarTrajecte);
		llisTrajecte= (Button) findViewById(R.id.llistarTrajectes);
		cercarTrajecte = (Button) findViewById(R.id.cercarTrajectes);
		comentari = (Button) findViewById(R.id.comentConductor);
		surtOpcions = (Button) findViewById(R.id.sortirOpcions);
		boto_ajuda = (Button) findViewById(R.id.boto_ajuda);


		//Capturem i tractem la pulsaci del bot publicar trajecte.

		pubTrajecte.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//pubTrajecte.setBackgroundColor(Color.rgb(153, 204, 0));
				publicarTrajecte(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot llistar trajectes.

		llisTrajecte.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//llisTrajecte.setBackgroundColor(Color.rgb(153, 204, 0));
				llistarTrajectes(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot cercar trajectes.

		cercarTrajecte.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//cercarTrajecte.setBackgroundColor(Color.rgb(153, 204, 0));
				cercarTrajecte(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot comentaris.

		comentari.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//comentari.setBackgroundColor(Color.rgb(153, 204, 0));
				ferComentari(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot sortir.

		surtOpcions.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//surtOpcions.setBackgroundColor(Color.rgb(153, 204, 0));
				sortir(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot ajuda.

		boto_ajuda.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				ajuda(view); //Cridem el mtode que gestiona l'acci.
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.registre, menu);
		return true;
	}


	/**
	 * Mtode que posa en marxa l'activitat que ens permetr publicar un nou
	 * trajecte.
	 * @param view
	 */
	private void publicarTrajecte(View view) {

		Intent i = new Intent(this, Publicar.class);
		startActivity(i);

	}

	/**
	 * Mtode que permetr visualitzar a un usuari els trajectes que t publicats.
	 * @param view
	 */
	public void llistarTrajectes(View view) {

		//Cridem el mtode de la classe ServeiLlistarTrajectes que cercar els
		//trajectes de l'usuari amb l'e_mail de sessi.
		ServeiLlistatTrajectes.accioLlistat(Usuari.e_mail);

		//Notifiquem que l'operaci pot tardar un temps.
		Toast.makeText(Opcions.getInstance().getBaseContext(),"" +
				"Aquesta operaci pot durar uns quants segons", 
				Toast.LENGTH_SHORT).show();
	}

	/**
	 * Mtode que inicia l'activitat que permetr la cerca per part d'un usuari, 
	 * d'un determinat trajecte.
	 * @param view
	 */
	private void cercarTrajecte(View view) {

		Intent inten = new Intent(this, Cerca.class);
		startActivity(inten);


	}

	/**
	 * Mtode que inicia l'activitat que permetr fer a un usuari, un comentari
	 * sobre un conductor.
	 * @param view
	 */
	private void ferComentari(View view) {
		Intent inten = new Intent(this, Comentari.class);
		startActivity(inten);

	}

	/**
	 * Mtode que gestiona la sortida de d'aquesta activitat.
	 * @param view
	 */
	private void sortir(View view) {


		finish(); //Finalitzem l'acci.

	}
	/**
	 * Mtode que posa en marxa l'activitat que mostre l'ajuda.
	 * @param view
	 */
	private void ajuda(View view) {

		Intent inten = new Intent(this, Ajuda.class);
		startActivity(inten);

	}
}
