package cat.pepweb.pep;

import java.util.ArrayList;

import cat.pepweb.pep.beans.Usuari;
import cat.pepweb.pep.serveis.ServeiPublicar;
import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

public class Publicar extends Activity {

	private EditText origen1;
	private EditText destinacio1;
	private EditText data1;
	private EditText hora1;
	private EditText minut1;
	private EditText model_cotxe1;
	private EditText places1;
	private EditText preu1;
	private Spinner mida_equipatge1;
	private CheckBox permes_fumar1;
	private CheckBox radio_mp31;
	private Button enviarTrajecte1;
	private Button tornarOpcions1;
	private String e_mail2;
	private String mida_equipatge;
	private static Publicar publicar;
	private ArrayList<String> data = new ArrayList<String>();
	public static int resultatOperacio = 3;


	public static Publicar getInstance(){ //Per els toast
		return publicar;
	}

	/** Called when the activity is first created. */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.noutrajecte);

		publicar = this;
		//Passem les entrades del formulari a entrades locals per gestionar-les.
		origen1 = (EditText) findViewById(R.id.origen);
		destinacio1= (EditText) findViewById(R.id.destinacio);
		data1 = (EditText) findViewById(R.id.data);
		hora1 = (EditText) findViewById(R.id.hora);
		minut1 = (EditText) findViewById(R.id.minut);
		model_cotxe1 = (EditText) findViewById(R.id.model);
		places1= (EditText) findViewById(R.id.places);
		preu1 = (EditText) findViewById(R.id.preu);
		mida_equipatge1 = (Spinner) findViewById(R.id.equipatge);
		permes_fumar1 = (CheckBox) findViewById(R.id.fumar);
		radio_mp31 = (CheckBox) findViewById(R.id.radio);
		enviarTrajecte1 = (Button)findViewById(R.id.enviarTrajecte);
		tornarOpcions1 = (Button)findViewById(R.id.tornarOpcions);
		e_mail2 = Usuari.e_mail;

		data.add("Petit");
		data.add("Mitj");
		data.add("Gran");

		//Recollim la mida d'equipatge seleccionada a l'spinner.

		mida_equipatge1.setOnItemSelectedListener(new OnItemSelectedListener(){

			public void onItemSelected(AdapterView<?> adapterView, View view, int position, long id){
				mida_equipatge = data.get(position);
			}
			public void onNothingSelected(AdapterView<?> parent)
			{    
			}
		});

		//Capturem i tractem la pulsaci del bot enviar trajecte.

		enviarTrajecte1.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//enviarTrajecte1.setBackgroundColor(Color.rgb(153, 204, 00));
				enviarTrajecte(view); //Cridem el mtode que gestiona l'acci.

			}
		});

		//Capturem i tractem la pulsaci del bot tornar a opcions.

		tornarOpcions1.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//tornarOpcions1.setBackgroundColor(Color.rgb(153, 204, 0));
				tornarOpcions(view); //Cridem el mtode que gestiona l'acci.
			}
		});

	}


	/**
	 * Mtode en el qual recollim els atributs del formulari i els enviem al
	 * web service per emmagatzemar el nou trajecte.
	 * @param view
	 */
	private void enviarTrajecte(View view) {

		ArrayList<String> dades = new ArrayList<String>();//Emmagatzemem les dades.

		//Recollim els atributs del formulari.

		String origen2 = origen1.getText().toString();
		String destinacio2 = destinacio1.getText().toString();
		String data2 = data1.getText().toString();
		String  model_cotxe2 = model_cotxe1.getText().toString();
		String hora2 = hora1.getText().toString();
		String minut2 = minut1.getText().toString();
		String places2 = places1.getText().toString();
		String preu2 = preu1.getText().toString();
		String mida_equipatge2 = mida_equipatge;
		boolean permes_fumar2 = Boolean.valueOf(permes_fumar1.isChecked());
		boolean radio_mp32 = Boolean.valueOf(radio_mp31.isChecked());


		boolean ok = true;


		//Comprovem que s'hagin omplert tots els camps i amb les dades correctes.

		if((origen2.equals(""))|| (destinacio2.equals(""))||(data2.equals(""))||
				(model_cotxe2.equals(""))|| (mida_equipatge2.equals(""))|| 
				(hora2.equals(""))|| (minut2.equals(""))|| (places2.equals(""))
				|| (preu2.equals(""))){
			ok = false;

			//Notifiquem que l'usuari no ha omplert tots els camps.
			Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
					"Error: no s'han omplert tots els camps" ,
					Toast.LENGTH_SHORT).show();
			//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));
		}

		//Comprovem que el format de la data sigui correcte.

		if(ok == true){

			String dia="";
			String separador1="";
			String mes="";
			String separador2="";
			String any1="";
			String any2="";
			String any3="";
			String any4="";
			int dia3 = 0;
			int mes3 = 0;
			//Carreguem la data  per comprovar el format.
			try{
				dia = data2.substring(0, 2);
				separador1 = data2.substring(2, 3);
				mes = data2.substring(3, 5);
				separador2 = data2.substring(2, 3);
				any1 = data2.substring(6, 7);
				any2 = data2.substring(7, 8);
				any3 = data2.substring(8, 9);
				any4 = data2.substring(9);
			}catch(Exception e){
				ok = false;
				//Notifiquem a l'usuari que la data t un format incorrecte.
				Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
						"El format de la data no s (dd/mm/yyyy)" ,
						Toast.LENGTH_SHORT).show();
				//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));

			}
			//Comprovem que la data est ben formatada.
			if(ok == true){
				try{
					dia3 = Integer.parseInt(dia);
					mes3 = Integer.parseInt(mes);
					Integer.parseInt(any1);
					Integer.parseInt(any2);
					Integer.parseInt(any3);
					Integer.parseInt(any4);

				}catch(Exception e){
					ok = false;
					//Notifiquem a l'usuari que la data t un format incorrecte.
					Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
							"El format de la data s incorrecte." ,
							Toast.LENGTH_SHORT).show();
					//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));

				}


				if(!((separador1.equals("/")) && (separador2.equals("/")))){
					ok = false;
					//Notifiquem a l'usuari que la data t un format incorrecte.
					Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
							"El format de la data s incorrecte." ,
							Toast.LENGTH_SHORT).show();
					//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));
				}

				//Comprovem que dia i mes estiguin en el rang.

				if(dia3 == 0 || dia3 >31 || mes3 ==0 || mes3 >12){
					ok = false;

					//Notifiquem a l'usuari que el dia o el mes estan fora de rang.
					Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
							"Dia o mes fora de rang." ,
							Toast.LENGTH_SHORT).show();
					//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));

				}
			}
		}

		//Comprovem que l'hora i minut estigui entre els marges.

		if(ok == true){

			try{
				int h = Integer.parseInt(hora2);
				int m = Integer.parseInt(minut2);
				if(h < 0 || h > 23 || m < 0 || m > 59){
					ok = false;

					//Notifiquem a l'usuari que l'hora o els minuts sn incorrecte.
					Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
							"Hora o minuts fora de rang." ,
							Toast.LENGTH_SHORT).show();
					//enviarTrajecte1.setBackgroundColor(Color.rgb(6, 227, 62));

				}

			}catch(Exception e){

			}

		}

		if(ok == true){

			//Formatem l'origen i dest a primera lletra majscula i resta minscules.
			String origen3 = origen2.substring(0, 1).toUpperCase()+
					origen2.substring(1).toLowerCase();
			String destinacio3 = destinacio2.substring(0, 1).toUpperCase()+
					destinacio2.substring(1).toLowerCase();
			//Afegim a la llista els noms i valors dels atributs de la ruta.
			dades.add("origen");
			dades.add(origen3);
			dades.add("destinacio");
			dades.add(destinacio3);
			dades.add("data");
			dades.add(data2);
			dades.add("hora");
			dades.add(hora2);
			dades.add("minut");
			dades.add(minut2);
			dades.add("model_cotxe");
			dades.add(model_cotxe2);
			dades.add("places");
			dades.add(places2);
			dades.add("preu");
			dades.add(preu2);
			dades.add("mida_equipatge");
			dades.add(mida_equipatge2);
			dades.add("e_mail");
			dades.add(e_mail2);
			dades.add("permes_fumar");
			dades.add(String.valueOf(permes_fumar2));
			dades.add("radio_mp3");
			dades.add(String.valueOf(radio_mp32));
			dades.add("tasca");
			dades.add("publicar");
			//Avisem que l'operaci pot tardar uns quants segons.
			Toast.makeText(Publicar.getInstance().getBaseContext(),"" +
					"Aquesta operaci pot tardar uns quants segons." ,
					Toast.LENGTH_SHORT).show();
			//Cridem el mtode de la classe ServeiPublicar que invocar el
			//servei del web que ha d'emmagatzemar el trajecte.
			ServeiPublicar.accioPublicar(dades);


		}



	}
	/**
	 * Mtode que mata l'activitat i tornem a opcions.
	 * @param view
	 */
	private void tornarOpcions(View view) {

		//Opcions.pubTrajecte.setBackgroundColor(Color.rgb(51, 35, 248));
		finish();

	}


}
