/**
 * 
 */
package cat.pepweb.pep;

import java.util.ArrayList;

import cat.pepweb.pep.beans.Usuari;
import cat.pepweb.pep.serveis.ServeiRegistre;
import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;




@TargetApi(Build.VERSION_CODES.GINGERBREAD)
@SuppressLint("NewApi")
public class Registre extends Activity {

	public static Button enviar1;
	private Button tornar1;

	private EditText nom;
	private EditText cognoms;
	private EditText contrasenya;
	private EditText email;
	private EditText anyNaixement;
	private EditText telefon;
	private CheckBox sexe;
	private CheckBox telfPublic;
	private CheckBox correuPublic;

	private static Registre registre;

	public static Registre getInstance(){
		return registre;
	}


	/** Called when the activity is first created. */
	@TargetApi(Build.VERSION_CODES.GINGERBREAD)
	@SuppressLint("NewApi")
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.registre);

		registre = this;

		nom = (EditText) findViewById(R.id.nom);
		cognoms = (EditText) findViewById(R.id.cognoms);
		contrasenya = (EditText) findViewById(R.id.contrasenya);
		email = (EditText) findViewById(R.id.email);
		anyNaixement = (EditText) findViewById(R.id.anyNaixement);
		telefon = (EditText) findViewById(R.id.telefon);
		sexe = (CheckBox) findViewById(R.id.sexe2);
		correuPublic = (CheckBox) findViewById(R.id.correuPublic);
		telfPublic = (CheckBox) findViewById(R.id.telefonPublic);
		//Detectem versi de l'Android installat en el dispositiu degut a que si s major
		// a 9, es t de crear una nova regla per l'StrictMode sin no funcionaria l'aplicaci.
		if(android.os.Build.VERSION.SDK_INT > 9){
			StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
		      StrictMode.setThreadPolicy(policy);
		}


		//Capturem i tractem la pulsaci del bot enviar.
		enviar1 = (Button)findViewById(R.id.enviar1);
		enviar1.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//enviar1.setBackgroundColor(Color.rgb(153, 204, 0));
				activarRegistre(view); //Cridem el mtode que gestiona l'acci.
			}
		});

		//Capturem i tractem la pulsaci del bot tornar.

		tornar1 = (Button)findViewById(R.id.tornar1);
		tornar1.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				tornarAMainActivity (view);

			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.registre, menu);
		return true;
	}

	/**
	 * Mtode que recull les dades d'entrada i les verifica per, desprs
	 * enviar-les per a que quedin guardades.
	 * @param view
	 */
	public void activarRegistre(View view){

		ArrayList<String> dades = new ArrayList<String>();//Emmagatzemem les dades.

		//Comprovem que s'hagin omplert tots els camps i amb les dades correctes.

		String nom1 = nom.getText().toString();
		String cognoms1 = cognoms.getText().toString();
		String e_mail1 = email.getText().toString();
		String  contrasenya1 = contrasenya.getText().toString();
		String telefon1 = telefon.getText().toString();
		boolean sexe1 = Boolean.valueOf(sexe.isChecked());
		boolean emailPublic1 = Boolean.valueOf(correuPublic.isChecked());
		boolean telefonPublic1 = Boolean.valueOf(telfPublic.isChecked());
		int anyNaixement1 = 0;
		boolean ok = true;
		int result = 3;

		//Comprovem que s'hagin omplert tots els camps i amb les dades correctes.

		if((nom1.equals(""))|| (cognoms1.equals(""))||(e_mail1.equals(""))||
				(telefon1.equals(""))|| (contrasenya1.equals(""))){
			ok = false;

			//Notifiquem que l'usuari no ha omplert tots els camps.
			Toast.makeText(Registre.getInstance().getBaseContext(),"" +
					"Error: no s'han omplert tots els camps" ,
					Toast.LENGTH_SHORT).show();
		}
		if(ok == true){ 
			try{

				anyNaixement1 = Integer.parseInt(anyNaixement.getText().toString());

			}catch (Exception e){
				ok = false;

				//Notifiquem que l'usuari no ha omplert b algun camp.
				Toast.makeText(Registre.getInstance().getBaseContext(),"" +
						"Error: L'any de naixement t que ser numric." ,
						Toast.LENGTH_SHORT).show();
			}
		}
		if(ok == true){

			dades.add("nom");
			dades.add(nom1);
			dades.add("cognoms");
			dades.add(cognoms1);
			dades.add("e_mail");
			dades.add(e_mail1);
			dades.add("anyNaixement");
			dades.add(String.valueOf(anyNaixement1));
			dades.add("telefon");
			dades.add(telefon1);
			dades.add("contrasenya");
			dades.add(contrasenya1);
			dades.add("sexe");
			dades.add(String.valueOf(sexe1));
			dades.add("telefonPublic");
			dades.add(String.valueOf(telefonPublic1));
			dades.add("e_mailPublic");
			dades.add(String.valueOf(emailPublic1));
			dades.add("tasca");
			dades.add("registre");

			result = ServeiRegistre.conectaPost(dades);

		}
		//Si el registre ha anat b enregistrem les dades de l'usuari a la classe
		//usuari per conservar-les en el transcurs de la sessi.

		if(result == 1){

			Usuari.nom = nom1;
			Usuari.cognoms = cognoms1;
			Usuari.e_mail = e_mail1;
			Usuari.contrasenya = contrasenya1;
			Usuari.any_naixement = anyNaixement1;
			Usuari.sexe = sexe1;
			Usuari.e_mail_public = emailPublic1;
			Usuari.telefon_public = telefonPublic1;

			//Notifiquem que l'usuari que el registre ha anat b.
			Toast.makeText(Registre.getInstance().getBaseContext(),"" +
					"Registre correcte." ,
					Toast.LENGTH_SHORT).show();

			Intent i = new Intent(this, Opcions.class);
			startActivity(i);//Finalitzem activitat i arranquem la d'opcions.
			finish();
		}
		if(result ==0){
			//Notifiquem que ja hi ha un usuari registrat amb el mateix correu.
			Toast.makeText(Registre.getInstance().getBaseContext(),"" +
					"Error: l'adrea de correu ja est registrada." ,
					Toast.LENGTH_SHORT).show();
		}
		if(result == 2){
			//Notifiquem que s'ha produt un error.
			Toast.makeText(Registre.getInstance().getBaseContext(),"" +
					"Error: el registre no s'ha pogut realitzar." ,
					Toast.LENGTH_SHORT).show();
		}


	}
	/**
	 * Sortim de l'activitat.
	 * @param view
	 */
	public void tornarAMainActivity(View view){

		//MainActivity.registre.setBackgroundColor(Color.rgb(00, 00, 255));
		finish();

	}

}
