package cat.pepweb.pep;


import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import cat.pepweb.pep.beans.Trajecte;
import cat.pepweb.pep.serveis.ServeiReserva;
import cat.pepweb.pep.serveis.ServeiVeureComentaris;

public class TrajecteCercatSeleccionat extends Activity {
	public static TrajecteCercatSeleccionat trajCerSelec;
	public static Bitmap fotografia;
	public static Trajecte trajecte;
	public static Button botoComentaris;
	public static Button botoSortir;
	public static Button botoReserva;
	public static Button botoMapa;

	public static TrajecteCercatSeleccionat getInstance(){ //Per els toast
		return trajCerSelec;
	}

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.trajecte_cercat_seleccionat);
		trajCerSelec = this;
		TextView infoTrajecte = (TextView) findViewById(R.id.info_trajecte);
		ImageView imatge = (ImageView) findViewById(R.id.imag);

		infoTrajecte.setText(trajecte.toString3());//Inserim oferta en el quadre de text.
		imatge.setImageBitmap(fotografia);//Inserim fotografia a l'ImageView.

		//Notifiquem a l'usuari que recordi l'id per poder fer un comentari ms tard.
		Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
				"Recordi aquest id de trajecte, doncs ser necessari si vol deixar " +
				"posteriorment un comentari del conductor." ,
				Toast.LENGTH_LONG).show();

		//Capturem i tractem la pulsaci del bot veure comentaris.

		botoComentaris = (Button)findViewById(R.id.veure_comentaris);
		botoComentaris.setOnClickListener(new OnClickListener(){
			public void onClick(View view){

				//botoComentaris.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot al prmer.
				veureComentaris(); //Finalitzem l'activitat.
			}
		});

		//Capturem i tractem la pulsaci del bot sortir.

		botoSortir = (Button)findViewById(R.id.tornar_seleccio);
		botoSortir.setOnClickListener(new OnClickListener(){
			public void onClick(View view){

				//botoSortir.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot al prmer.
				finish(); //Finalitzem l'activitat.
			}
		});


		//Capturem i tractem la pulsaci del bot fer reserva.

		botoReserva = (Button)findViewById(R.id.fer_reserva);
		botoReserva.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//botoReserva.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot en prmer.
				ferReserva();
			}
		});

		//Capturem i tractem la pulsaci del bot veure mapa.

		botoMapa = (Button)findViewById(R.id.veure_mapa);
		botoMapa.setOnClickListener(new OnClickListener(){
			public void onClick(View view){

				//botoMapa.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot en prmer.

				veureRuta();
			}
		});

	}

	/**
	 * Mtode que invoca la lgica per a presentar els comentaris del conductor
	 * del trajecte seleccionat.
	 */
	public void veureComentaris(){


		ServeiVeureComentaris.accioCercar(trajecte.getE_mail());

		//Notifiquem que l'operaci pot tardar uns segons.
		Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
				"Aquesta operaci pot tardar uns segons.", 
				Toast.LENGTH_SHORT).show();

	}

	/**
	 * Mtode que posa en marxa l'activitat de fer una reserva.
	 */
	public void ferReserva(){


		String text = "Per reservar plaa i concretar qualsevol altre aspecte " +
				"del viatge, es pot posar en contacte amb el conductor " +
				"mitjanant aquesta adrea de correu: ";
		String[] resultat = ServeiReserva.accioCercar(trajecte.getE_mail());
		if(resultat[1].equals("true")){
			text = text + trajecte.getE_mail();
		}else{
			text = text + "webmaster@pepweb.cat ";
		}
		if(!(resultat[0].equals("null"))){
			text = text + " i tamb a travs del nmero de telfon: " + 
					resultat[0];
		}

		Intent intent = new Intent(this, Reserva.class);
		intent.putExtra("text", text);//Enviem el text que ha de presentar l'activitat.
		startActivity(intent);

	}

	/**
	 * Mtode que posa en marxa l'activitat de veure la ruta en un mapa.
	 * 
	 */
	public void veureRuta(){

		Mapa.trajecte=trajecte;

		Intent intent = new Intent(this, Mapa.class);
		startActivity(intent);


	}
	/**
	 * Mtode que finalitza aquesta activitat cridat quan es prem el boto de tornar.
	 */
	public void sortirActivitat(){

		finish();	

	}

}
