package cat.pepweb.pep;


import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import cat.pepweb.pep.beans.Trajecte;
import cat.pepweb.pep.serveis.ServeiEsborrar;

public class TrajecteSeleccionat extends Activity {

	public static TrajecteSeleccionat trajecteSeleccionat;
	public static Bitmap fotografia;
	public static Trajecte trajecte;
	private Button botoSortir;
	public static Button botoEsborrar;
	public static Button botoModificar;

	public static TrajecteSeleccionat getInstance(){ //Per els toast
		return trajecteSeleccionat;
	}

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.trajecte_seleccionat);
		trajecteSeleccionat = this;

		TextView infoTrajecte = (TextView) findViewById(R.id.info_trajecte);
		ImageView imatge = (ImageView) findViewById(R.id.imag);

		infoTrajecte.setText(trajecte.toString2());//Inserim oferta en el quadre de text.
		imatge.setImageBitmap(fotografia);//Inserim fotografia a l'ImageView.



		//Capturem i tractem la pulsaci del bot sortir.

		botoSortir = (Button)findViewById(R.id.tornar_seleccio);
		botoSortir.setOnClickListener(new OnClickListener(){
			public void onClick(View view){

				//botoSortir.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot al prmer.
				finish(); //Finalitzem l'activitat.
			}
		});


		//Capturem i tractem la pulsaci del bot esborrar.

		botoEsborrar = (Button)findViewById(R.id.esborrar);
		botoEsborrar.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				//botoEsborrar.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot en prmer.
				esborrarTrajecte();
			}
		});

		//Capturem i tractem la pulsaci del bot modificar.

		botoModificar = (Button)findViewById(R.id.modificar);
		botoModificar.setOnClickListener(new OnClickListener(){
			public void onClick(View view){

				//botoModificar.setBackgroundColor(Color.rgb(153, 204, 00));//Canviem el color del bot en prmer.

				modificarTrajecte();
			}
		});

	}

	/**
	 * Mtode que posa en marxa l'activitat d'esborrar el trajecte.
	 */
	public void esborrarTrajecte(){


		//Presentem un dileg per donar una segona oportunitat abans d'esborrar.

		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage("Est segur d'esborrar aquest trajecte?")
		.setCancelable(false)
		.setPositiveButton("Si", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {

				int result = ServeiEsborrar.accioEsborrar(trajecte.getId());
				if (result == 1){


					sortirActivitat();

				}


			}
		})
		.setNegativeButton("No", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				dialog.cancel();
				//botoEsborrar.setBackgroundColor(Color.rgb(6, 227, 62));
			}
		});
		AlertDialog alert = builder.create();
		alert.show();







		//Intent intent = new Intent(this, Mapas.class);
		//startActivity(intent);

	}

	/**
	 * Mtode que posa en marxa l'activitat de modificar el trajecte.
	 * 
	 */
	public void modificarTrajecte(){
		Intent intent = new Intent (this, ModificarTrajecte.class);
		startActivity(intent);
		finish();


	}

	/**
	 * Sortim de l'activitat.
	 */
	public void sortirActivitat(){

		//Aturem l'activitat LlistatTrajectes per obligar a tornar-la a executar
		//per tal que refresqui la llista de trajectes.
		LlistatTrajectes.llistaTrajectes.clear();
		LlistatTrajectes.llistaImatges.clear();
		LlistatTrajectes.getInstance().finish();

		finish();


	}

}
