package cat.pepweb.pep.eines;

import java.util.Vector;

import android.content.Context;
import android.graphics.Bitmap;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import cat.pepweb.pep.R;
import cat.pepweb.pep.beans.Trajecte;


public class Adaptador extends ArrayAdapter<Trajecte> {
	private final Context context;
	private final Vector<Trajecte> llista;
	private final Vector <Bitmap>llistaImatges;

	//Constructor
	public Adaptador(Context context,int a,  Vector<Trajecte> llista,
			Vector<Bitmap> llistaImatges) {

		super(context,a, llista);
		this.context=context;
		this.llista=llista;
		this.llistaImatges=llistaImatges;
	}


	@Override
	public View getView(int position, View convertView, ViewGroup parent) {

		Trajecte trajecte = null;

		View view = convertView;
		//Generem la vista si no existeix.
		if(view == null){
			LayoutInflater vi = (LayoutInflater) 
					context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			view = vi.inflate(R.layout.element_llista, null);
		}
		if(llista.size()!= 0){
			trajecte = llista.get(position);//Recuperem l'oferta de la llista.
		}
		if(trajecte != null){
			TextView tt = (TextView) view.findViewById(R.id.dades_trajecte);//Recuperem la caixa de text del layout.
			ImageView im = (ImageView) view.findViewById(R.id.icona);//Recuperem l'espai per la imatge en el layout.
			if(im != null && llistaImatges.size()!= 0){
				im.setImageBitmap((llistaImatges.get(position)));//Inserim la imatge de l'oferta emmagatzemada a la llista.
			}
			if(tt != null){
				tt.setText(trajecte.toString());//Inserim l'oferta.
			}
		}
		return view;
	}


}
