package cat.pepweb.pep.serveis;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONObject;
import org.mapsforge.core.GeoPoint;

import android.util.Log;
import android.widget.Toast;
import cat.pepweb.pep.Mapa;



public class ServeiCercarPunts{

	static GeoPoint[][] ruta;


	/**
	 * Amb aquest mtode enviem l'origen i destinaci de la ruta seleccionada i 
	 * de la qual volem veure en el mapa, i obtenim els punts de la ruta. 
	 * @param user
	 * @param pass
	 */
	public static int accioCercarPunts(ArrayList<String> parametres){



		ArrayList<BasicNameValuePair> nameValuePairs;
		InputStream content = null;
		StringBuilder builder = new StringBuilder();
		
		

		//Preparaci de la connexi i de les dades que s'han d'enviar.
		try {
			HttpClient httpclient = new DefaultHttpClient();
			HttpPost httppost = new HttpPost("http://www.pepweb.cat:8888/WebServicePfc/Controlador");
			nameValuePairs = new ArrayList<BasicNameValuePair>();
			if (parametres != null) {//Formem parells clau / valor.
				for (int i = 0; i < parametres.size(); i += 2) {
					nameValuePairs.add(new BasicNameValuePair
							((String)parametres.get(i), (String)parametres.get(i + 1)));
				}
				httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
			}//S'executa la connexi i s'espera la resposta.
			HttpResponse response = httpclient.execute(httppost);
			HttpEntity entity = response.getEntity();
			content = entity.getContent();//El passem a un InputStream.
			BufferedReader reader = new BufferedReader(new InputStreamReader(content));
			//Passem la resposta unificada en un String. 
			String line;
			while ((line = reader.readLine()) != null) {
				builder.append(line);
			}
			try{
			content.close();//Ens assegurem que quedi tancada la connexi.
			}catch(Exception e){
				//Notifiquem error en la recepci de les dades.
				Toast.makeText(Mapa.getInstance().getBaseContext(),"" +
						"S'ha produit un error", 
						Toast.LENGTH_SHORT).show();
			}
		} catch (Exception e) {
			Log.e("log_tag", "Error in http connection " + e.toString());
		} finally {

		}


		String cadenaJSON = builder.toString();
		//Log.e("Punts: ", cadenaJSON );

		try{
			//Tractem l'objecte enviat com un  objecte formatat en JSON (que 
			//s com arriba).
			
			JSONObject json_data = new JSONObject(cadenaJSON);
			JSONArray llista = new JSONArray();
			llista = json_data.getJSONArray("usuari");//Extracci de l'array.
			//Log.e("Longitud llista: ", String.valueOf(llista.length()));
			//Dimensionem els Array.
			if(llista.length() != 0){//Verifiquem que existeixi la ruta.
			GeoPoint[] gp1 = new GeoPoint[llista.length()/2];
			Mapa.ruta = new GeoPoint[1][llista.length()/2];
			//Carreguem els punts per dibuixar la ruta.
			int index = 0;

			for(int i = 0; i<llista.length(); i+=2){

				gp1[index] = new GeoPoint (llista.getDouble(i), llista.getDouble(i+1));
				Mapa.ruta[0][index]= gp1[index];
				index = index+1;
			}
			//Centrarem el mapa en el primer punt de la ruta.
			double latitud = Mapa.ruta[0][0].getLatitude();
			double longitud = Mapa.ruta[0][0].getLongitude();
			Mapa.centrat = new GeoPoint(latitud, longitud);
			}else{
				return 5;
			}

		}catch(Exception e){
			//Notifiquem error en l'extracci de les dades.
			Toast.makeText(Mapa.getInstance().getBaseContext(),"" +
					"S'ha produit un error", 
					Toast.LENGTH_SHORT).show();
			//Log.e("Error: ", e.toString());
			return 0;

		}

		return 1;
	}

}
