package cat.pepweb.pep.serveis;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONObject;

import android.content.Intent;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.Log;
import android.widget.Toast;
import cat.pepweb.pep.Cerca;
import cat.pepweb.pep.LlistatTrajectesCercats;
import cat.pepweb.pep.R;
import cat.pepweb.pep.beans.Trajecte;



public class ServeiCercarTrajectes{
	private static Thread threadPublicar;
	private static String  org1;
	private static String dst1;
	private static String dt1;


	/**
	 * Amb aquest mtode enviem la dada per el llista al web service i si
	 * l'usuari t trajectes publicats ens retorna una llista amb tots ells i 
	 * la guardem a la classe LlistatTrajectes ja que ens serviran per a 
	 * poder-los imprimir i presentar a l'usuari.
	 * @param user
	 * @param pass
	 */
	public static int accioCercar(final String org, final String dst, final String dt){

		threadPublicar = new Thread(){
			public  void run(){

				org1 =org;
				dst1 = dst;
				dt1 = dt;

				HttpGet httpGet = new HttpGet("http://www.pepweb.cat:8888/WebServicePfc/Controlador?tasca=cercar&origen="+
						org1+"&destinacio="+dst1+"&data="+dt);
				StringBuilder builder = new StringBuilder();
				HttpClient client = new DefaultHttpClient();
				InputStream content = null;

				try {
					HttpResponse response = client.execute(httpGet);//Crida al web service.

					StatusLine statusLine = response.getStatusLine();//Estat de la petici.

					int statusCode = statusLine.getStatusCode();


					//Amb codi 200 el servidor ha respost.
					if (statusCode == 200) {
						HttpEntity entity = response.getEntity();//Recollim l'objecte.
						content = entity.getContent();//El passem a un BufferReader.
						BufferedReader reader = new BufferedReader(new InputStreamReader(content));
						//Passem la resposta unificada en un String. 
						String line;
						while ((line = reader.readLine()) != null) {
							builder.append(line);
						}
					} else {
						Log.e("","Failed to download data");
					}try{
						content.close();//Ens assegurem que quedi tancada la connexi.
					}catch(Exception e){

						//Notifiquem error en la recepci de les dades.
						Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
								"S'ha produit un error de comunicaci", 
								Toast.LENGTH_SHORT).show();

					}

				} catch (ClientProtocolException e) {
					e.printStackTrace();
					//return 0;

				} catch (IOException e) {
					e.printStackTrace();
					//return 0;

				}

				String cadenaJSON = builder.toString();
				//Log.e("Trajectes: ", cadenaJSON );

				try{
					//Tractem l'objecte enviat com un  objecte formatat en JSON (que 
					//s com arriba).

					JSONObject json_data = new JSONObject(cadenaJSON);
					JSONArray llista = new JSONArray();
					llista = json_data.getJSONArray("usuari");//Extracci de l'Array.

					for(int i = 0; i<llista.length(); i++){
						Log.e("Trajectes: ", String.valueOf(llista.length()));
						JSONObject json_dataElement = llista.getJSONObject(i);//Extracci dels elements.
						String origen = json_dataElement.getString("origen");
						String destinacio = json_dataElement.getString("destinacio");
						String data = json_dataElement.getString("data");
						String model_cotxe = json_dataElement.getString("model_cotxe");
						String mida_equipatge = json_dataElement.getString("mida_equipatge");
						String e_mail = json_dataElement.getString("e_mail");
						int id = json_dataElement.getInt("id");
						int hora = json_dataElement.getInt("hora");
						int minut = json_dataElement.getInt("minut");
						int places = json_dataElement.getInt("places");
						int distancia = json_dataElement.getInt("distancia");
						int temps = json_dataElement.getInt("temps");
						Double preu = json_dataElement.getDouble("preu");
						boolean permes_fumar = json_dataElement.getBoolean("permes_fumar");
						boolean radio_mp3 = json_dataElement.getBoolean("radio_mp3");

						Trajecte trajecte = new Trajecte(origen, destinacio, data, model_cotxe,
								mida_equipatge, e_mail, id, hora, minut, places, distancia,
								temps, preu, permes_fumar, radio_mp3);

						LlistatTrajectesCercats.llistaTrajectes.add(trajecte);//Afegim trajecte a la llista.
					}


				}catch(Exception e){
					//Notifiquem error en l'extracci de les dades.
					Toast.makeText(Cerca.getInstance().getBaseContext(),"" +
							"S'ha produt un error", 
							Toast.LENGTH_SHORT).show();
					//Log.e("Error: ", e.toString());

				}


				//Carreguem les imatges a presentar junt amb el llistat i que estan guardades
				//a recursos/drawables. En un altre versi es podrien descarregar del web
				// service i podrien ser imatges pujades pel usuari.
				Resources res = Cerca.getInstance().getResources();
				int numeroRecurs = R.drawable.aaacar1;
				int comptador = 0;
				Bitmap bitmap;
				Drawable d;
				//Carreguem els dibuixos a la llista pel Adaptador.
				for(int x = 0; x <LlistatTrajectesCercats.llistaTrajectes.size(); x++){
					d = res.getDrawable(numeroRecurs);
					bitmap =((BitmapDrawable)d).getBitmap();//Drawable --> Bitmap.
					LlistatTrajectesCercats.llistaImatges.add (bitmap);
					numeroRecurs = numeroRecurs +1;
					comptador = comptador + 1;
					if(comptador == 10){//S s'acaben els dibuixos, tornem a comenar pel primer.
						numeroRecurs = R.drawable.aaacar1;
						comptador = 0;
					}
				}


				//Llancem la nova activitat.

				Intent inten = new Intent(Cerca.getInstance(), LlistatTrajectesCercats.class);
				Cerca.getInstance().startActivity(inten);


			}
		};
		threadPublicar.start();





		return 1;
	}

}
