package cat.pepweb.pep.serveis;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONObject;

import cat.pepweb.pep.Login;
import cat.pepweb.pep.beans.Usuari;

import android.util.Log;
import android.widget.Toast;


public class ServeiLogin {

	/**
	 * Amb aquest mtode enviem les dades per el login en el web service i si
	 * l'usuari ha estat identificat ens retorna totes les seves dades que 
	 * les guardem a la classe Usuari ja que ens serviran per conservar la 
	 * identitat d'aquest en el transcurs de tota la sessi.
	 * @param user
	 * @param pass
	 */
	public static int accioLogin(final String user,final String pass){

		StringBuilder builder = new StringBuilder();
		HttpClient client = new DefaultHttpClient();
		HttpGet httpGet = new HttpGet("http://www.pepweb.cat:8888/WebServicePfc/Controlador?tasca=login&e_mail="+user+"&contrasenya="+pass);
		InputStream content = null;

		try {
			HttpResponse response = client.execute(httpGet);//Crida al web service.

			StatusLine statusLine = response.getStatusLine();//Estat de la petici.

			int statusCode = statusLine.getStatusCode();
			//Log.e("Valor", String.valueOf(statusCode));
			//Amb codi 200 el servidor ha respost.
			if (statusCode == 200) {
				HttpEntity entity = response.getEntity();//Recollim l'objecte.
				content = entity.getContent();//El passem a un BafferReader.
				BufferedReader reader = new BufferedReader(new InputStreamReader(content));
				//Passem la resposta unificada en un String. 
				String line;
				while ((line = reader.readLine()) != null) {
					builder.append(line);
				}
			} else {
				Log.e("","Failed to download data");
			}try{
				content.close();//Ens assegurem que quedi tancada la connexi.
			}catch(Exception e){
				//Notifiquem error en la recepci de les dades.
				Toast.makeText(Login.getInstance().getBaseContext(),"" +
						"S'ha produit un error de comunicaci", 
						Toast.LENGTH_SHORT).show();
			}

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			return 0;
		} catch (IOException e) {
			e.printStackTrace();
			return 0;
		}

		String cadenaJSON = builder.toString();

		try{
			//Tractem l'objecte enviat com un  objecte formatat en JSON (que 
			//s com arriba).
			JSONObject json_data = new JSONObject(cadenaJSON);
			JSONArray usuaris = new JSONArray();
			usuaris = json_data.getJSONArray("usuari");//Extracci de l'Array.
			JSONObject json_dataElement = usuaris.getJSONObject(0);//Extracci element 1.
			if(json_data != null){ //Notifiquem registre ok.
				Toast.makeText(Login.getInstance().getBaseContext(),"" +
						"L'usuari: " + json_dataElement.getString("nom") + 
						" amb adrea de correu: " + json_dataElement.getString("e_mail") +
						" ha estat identificat correctament. ", Toast.LENGTH_SHORT).show();
				//Guardem les dades de l'usuari.

				Usuari.id = json_dataElement.getInt("id");
				Usuari.nom = json_dataElement.getString("nom");
				Usuari.cognoms = json_dataElement.getString("cognoms");
				Usuari.e_mail = json_dataElement.getString("e_mail");
				Usuari.any_naixement = json_dataElement.getInt("anyNaixement");
				Usuari.telefon = json_dataElement.getString("telefon");
				Usuari.contrasenya = json_dataElement.getString("contrasenya");
				Usuari.sexe = json_dataElement.getBoolean("sexe");
				Usuari.telefon_public = json_dataElement.getBoolean("telefonPublic");
				Usuari.e_mail_public = json_dataElement.getBoolean("e_mailPublic");
				//Log.e("Usuari: ", cadenaJSON );//Imprimim l'objecte que ens arriba en el log
				return 1;

			}
		}catch(Exception e){
			//Notifiquem que l'usuari no ha estat identificat.
			Toast.makeText(Login.getInstance().getBaseContext(),"" +
					"L'usuari amb adrea de correu: " + user+ 
					" no ha estat identificat.", 
					Toast.LENGTH_SHORT).show();
			return 0;

		}
		return 0;

	}
}
