package cat.pepweb.pep.serveis;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.util.Log;
import android.widget.Toast;
import cat.pepweb.pep.TrajecteCercatSeleccionat;




public class ServeiReserva{



	/**
	 * Amb aquest mtode enviem el e_mail de la persona que ha publicat el trajecte
	 * del qual reserva plaa l'usuari, cap el web service invocant el servei
	 * de reserva, i aquest ens retornar el telfon si aquest el tenia marcat com
	 * a pblic, i tamb ens dir si l'adrea de correu electrnic s pblica i
	 * per tant, se li pot subministrar en l'usuari.
	 * @param user
	 * @param pass
	 */
	public static String[] accioCercar(String e_mail){


		HttpGet httpGet = new HttpGet("http://www.pepweb.cat:8888/WebServicePfc/" +
				"Controlador?tasca=reserva&correu="+e_mail);
		StringBuilder builder = new StringBuilder();
		HttpClient client = new DefaultHttpClient();
		InputStream content = null;
		String[]params = null;

		try {
			HttpResponse response = client.execute(httpGet);//Crida al web service.

			StatusLine statusLine = response.getStatusLine();//Estat de la petici.

			int statusCode = statusLine.getStatusCode();
			//Log.e("Valor", String.valueOf(statusCode));
			//Amb codi 200 el servidor ha respost.
			if (statusCode == 200) {
				HttpEntity entity = response.getEntity();//Recollim l'objecte.
				content = entity.getContent();//El passem a un BufferReader.
				BufferedReader reader = new BufferedReader(new InputStreamReader(content));
				//Passem la resposta unificada en un String. 
				String line;
				while ((line = reader.readLine()) != null) {
					builder.append(line);
				}
			} else {
				Log.e("","Failed to download data");
			}try{
				content.close();//Ens assegurem que quedi tancada la connexi.
			}catch(Exception e){
				//Notifiquem error en la recepci de les dades.
				Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
						"S'ha produit un error de comunicaci", 
						Toast.LENGTH_SHORT).show();
			}

		} catch (ClientProtocolException e) {
			e.printStackTrace();
			return params;

		} catch (IOException e) {
			e.printStackTrace();
			return params;

		}

		String cadena = builder.toString();


		try{
			//Separem l'String que ens arriba per extreure els dos parmetres.

			params = cadena.split(",");

		}catch(Exception e){
			//Notifiquem error en l'extracci de les dades.
			Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
					"S'ha produt un error", 
					Toast.LENGTH_SHORT).show();
			Log.e("Error: ", e.toString());

		}

		return params;
	}

}
