package cat.pepweb.pep.serveis;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONObject;

import android.content.Intent;
import android.util.Log;
import android.widget.Toast;
import cat.pepweb.pep.TrajecteCercatSeleccionat;
import cat.pepweb.pep.VeureComentaris;




public class ServeiVeureComentaris{

	private static Thread threadPublicar;
	private static String  Email;

	/**
	 * Amb aquest mtode enviem la dada per el llista al web service i si
	 * l'usuari t comentaris guardats ens retorna una llista amb tots ells i 
	 * la guardem a la classe VeureComentaris ja que ens serviran per a 
	 * poder-los imprimir i presentar a l'usuari.
	 * @param user
	 * @param pass
	 */
	public static int accioCercar(final String e_mail){

		threadPublicar = new Thread(){
			public  void run(){

				Email = e_mail;
				int ok = 1;


				HttpGet httpGet = new HttpGet("http://www.pepweb.cat:8888/WebServicePfc/Controlador?tasca=" +
						"veure_comentaris&e_mail="+Email);
				StringBuilder builder = new StringBuilder();
				HttpClient client = new DefaultHttpClient();
				InputStream content = null;

				try {
					HttpResponse response = client.execute(httpGet);//Crida al web service.

					StatusLine statusLine = response.getStatusLine();//Estat de la petici.

					int statusCode = statusLine.getStatusCode();
					//Log.e("Valor", String.valueOf(statusCode));
					//Amb codi 200 el servidor ha respost.
					if (statusCode == 200) {
						HttpEntity entity = response.getEntity();//Recollim l'objecte.
						content = entity.getContent();//El passem a un BufferReader.
						BufferedReader reader = new BufferedReader(new InputStreamReader(content));
						//Passem la resposta unificada en un String. 
						String line;
						while ((line = reader.readLine()) != null) {
							builder.append(line);
						}
					} else {
						Log.e("","Failed to download data");
					}try{
						content.close();//Ens assegurem que quedi tancada la connexi.
					}catch(Exception e){
						//Notifiquem error en la recepci de les dades.
						Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
								"S'ha produit un error de comunicaci", 
								Toast.LENGTH_SHORT).show();
					}

				} catch (ClientProtocolException e) {
					e.printStackTrace();
					ok = 0;

				} catch (IOException e) {
					e.printStackTrace();
					ok = 0;

				}

				String cadenaJSON = builder.toString();
				//Log.e("Comentaris: ", cadenaJSON );

				try{
					//Tractem l'objecte enviat com un  objecte formatat en JSON (que 
					//s com arriba).
					JSONObject json_data = new JSONObject(cadenaJSON);
					JSONArray llista = new JSONArray();
					llista = json_data.getJSONArray("comentaris");//Extracci de l'Array.

					for(int i = 0; i<llista.length(); i++){
						Log.e("Comentaris: ", String.valueOf(llista.length()));
						JSONObject json_dataElement = llista.getJSONObject(i);//Extracci dels elements.
						String nom = json_dataElement.getString("nom");
						//String cognom = json_dataElement.getString("cognom");
						String comentari = json_dataElement.getString("comentari");
						//String e_mail1 = json_dataElement.getString("e_mail");
						//int id = json_dataElement.getInt("id");
						int puntuacio = json_dataElement.getInt("puntuacio");
						String puntuacio1 = String.valueOf(puntuacio);
						String comentaris = nom + ": \n" + "Puntuaci: " + puntuacio1 +
								"\n" + "Comentari: \n" + comentari; 


						VeureComentaris.coments.add(comentaris);//Afegim comentari a la llista.

					}	
				}catch(Exception e){
					//Notifiquem error en l'extracci de les dades.
					Toast.makeText(TrajecteCercatSeleccionat.getInstance().getBaseContext(),"" +
							"S'ha produt un error", 
							Toast.LENGTH_SHORT).show();
					//Log.e("Error: ", e.toString());

				}
				//Afegim comentari / "bot" de sortir.
				VeureComentaris.coments.add("----------Tornar----------");

				//Llancem la nova activitat si no hi ha cap error.

				if(ok == 1){
					Intent intent = new Intent(TrajecteCercatSeleccionat.
							getInstance(), VeureComentaris.class);
					TrajecteCercatSeleccionat.getInstance().startActivity(intent);	
				}

			}
		};
		threadPublicar.start();
		return 1;
	}

}
