package cat.pepweb.pep.controlador;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;
import cat.pepweb.pep.beans.Comentari;
import cat.pepweb.pep.beans.Trajectes;
import cat.pepweb.pep.beans.Usuari;
import cat.pepweb.pep.negoci.AfegirComentari;
import cat.pepweb.pep.negoci.AfegirTrajecte;
import cat.pepweb.pep.negoci.CercarComentaris;
import cat.pepweb.pep.negoci.CercarPunts;
import cat.pepweb.pep.negoci.CercarTrajectes;
import cat.pepweb.pep.negoci.EsborrarTrajecte;
import cat.pepweb.pep.negoci.LlistarTrajectesUsuari;
import cat.pepweb.pep.negoci.Login;
import cat.pepweb.pep.negoci.ModificarTrajecte;
import cat.pepweb.pep.negoci.Registre;
import cat.pepweb.pep.negoci.Reserva;

/**
 * Servlet implementation class Controlador
 */
public class Controlador extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public Controlador() {
		super();

	}

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {





		String tascaAFer = request.getParameter("tasca");//Recollim el tipus d'operaci a fer.
		//Registre de nou usuari.
		if(tascaAFer.equals("registre")){

			registrarUsuari(request, response);

		}//Login
		else if(tascaAFer.equals("login")){

			loginUsuari(request, response);

		}//Publicar nova ruta.
		else if(tascaAFer.equals("publicar")){

			publicarTrajecte(request, response);

		}//Llistar trajectes d'un usuari.
		else if(tascaAFer.equals("llistar")){

			llistarTrajectes(request, response);

		}//Esborrar trajecte publicat.
		else if(tascaAFer.equals("esborrar")){

			esborrarTrajecte(request, response);

		}//Modificar una ruta.

		else if(tascaAFer.equals("modificar")){

			modificarTrajecte(request, response);

		}//Cercar una ruta.
		else if(tascaAFer.equals("cercar")){

			cercarTrajecte(request, response);

		}//Enregistrar nou comentari per part d'un usuari a un conductor.

		else if(tascaAFer.equals("comentari")){

			afegirComentari(request, response);

		}//Enviem  e_mail i telfon si sn pblics.

		else if(tascaAFer.equals("reserva")){

			ferReserva(request, response);

		}//Enviem comentaris fets a un conductor si en t.

		else if(tascaAFer.equals("veure_comentaris")){

			veureComentaris(request, response);

		}
	}

	/**
	 * Mtode que ens permetr d'enregistrar un nou usuari.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void registrarUsuari(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		String nom = request.getParameter("nom");
		String cognoms = request.getParameter("cognoms");
		int anyNaixement = Integer.parseInt(request.getParameter("anyNaixement"));
		String e_mail = request.getParameter("e_mail");
		String telefon = request.getParameter("telefon");
		String contrasenya = request.getParameter("contrasenya");
		boolean sexe = Boolean.valueOf(request.getParameter("sexe"));
		boolean telefonPublic = Boolean.valueOf(request.getParameter("telefonPublic"));
		boolean e_mailPublic = Boolean.valueOf(request.getParameter("e_mailPublic"));
		Usuari usuari = new Usuari(nom, cognoms, anyNaixement, e_mail, telefon, contrasenya,
				sexe, telefonPublic, e_mailPublic);
		Registre registre = new Registre();
		int result = registre.registrarUsuari(usuari);
		responseRegistre(response, result);

	}
	/**
	 * Resposta a la petici de registre. Retorna un codi numric de l'1 al tres depenent del resultat 
	 * de l'alta del nou usuari.
	 * @param resp
	 * @param msg
	 * @throws IOException
	 */
	private void responseRegistre(HttpServletResponse resp, int msg)
			throws IOException {

		PrintWriter out = resp.getWriter();
		out.println(msg);
		System.out.println(msg);
	}

	/**
	 * Mtode que permetr autentificar un usuari enregistrat.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void loginUsuari(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		String e_mail = request.getParameter("e_mail");
		String contrasenya = request.getParameter("contrasenya");
		Login ol = new Login();
		Usuari user = new Usuari();
		user = ol.login(e_mail, contrasenya);
		responseLogin(response, user);


	}

	/**
	 * Resposta a la petici de Login. Retorna un codi numric de 0  1 depenent del resultat 
	 * del login de l'usuari.
	 * @param resp
	 * @param user
	 * @throws IOException
	 */
	private void responseLogin(HttpServletResponse resp, Usuari user)
			throws IOException {

		JSONObject cadena = new JSONObject();
		ArrayList<Usuari> llista = new ArrayList<Usuari>();
		llista.add(user);
		cadena.put("usuari", llista);

		resp.setContentType("application/json");
		resp.setCharacterEncoding("UTF-8");
		//resp.getWriter().write(new Gson().toJson(llista));
		PrintWriter out = resp.getWriter();
		out.println(cadena);
	}

	/**
	 * Mtode que far possible afegir un nou comentari cap un conductor.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void afegirComentari(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		int id = Integer.parseInt(request.getParameter("id"));
		int puntuacio = Integer.parseInt(request.getParameter("puntuacio"));
		String comentari = request.getParameter("comentari");
		Comentari coment = new Comentari();
		coment.setPuntuacio(puntuacio);
		coment.setComentari(comentari);
		coment.setId(id);
		AfegirComentari aCom = new AfegirComentari();
		int result = aCom.afegirUnComentari(coment);
		responseAfegirComentari(response, result);

	}

	/**
	 * Resposta a la petici d'afegir un comentari. Retorna un codi numric de 0  1 depenent del  
	 * resultat de l'alta del nou comentari.
	 * @param resp
	 * @param msg
	 * @throws IOException
	 */
	private void responseAfegirComentari(HttpServletResponse resp, int msg)
			throws IOException {

		PrintWriter out = resp.getWriter();
		out.println(msg);
	}

	/**
	 * Mtode que permetr retornar a l'usuari un llistat dels trajectes que t publicats.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void llistarTrajectes(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		String e_mail = request.getParameter("e_mail");
		List <Trajectes> llistaTrajectes = new ArrayList<Trajectes>();
		LlistarTrajectesUsuari llisTrajUsu = new LlistarTrajectesUsuari();
		llistaTrajectes = llisTrajUsu.llistarTrajectes(e_mail);
		responseLlistarTrajectes(response, llistaTrajectes);
	}


	/**
	 * Resposta a la petici de llistar trajectes. Retorna una llista amb els trajectes que s'han trobat 
	 * publicats de l'usuari que ha fet la petici.
	 * @param resp
	 * @param llista
	 * @throws IOException
	 */
	private void responseLlistarTrajectes(HttpServletResponse resp, List<Trajectes> llista)
			throws IOException {


		JSONObject cadena = new JSONObject();
		cadena.put("usuari", llista);

		resp.setContentType("application/json");
		resp.setCharacterEncoding("UTF-8");
		PrintWriter out = resp.getWriter();
		out.println(cadena);
	}

	/**
	 * Aquest mtode far possible que els usuaris esborrin trajectes.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void esborrarTrajecte(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		int idTrajecte = Integer.parseInt(request.getParameter("id"));
		EsborrarTrajecte eT = new EsborrarTrajecte();
		int result = eT.esborrarTrajecte(idTrajecte);
		responseEsborrarTrajecte(response, result);
	}

	/**
	 * Resposta a la petici d'esborrar un trajecte. Retorna 0  1 depenent del resultat de l'operaci. 
	 * Un 1 si tot ha funcionat b o un 0 en cas contrari.
	 * @param resp
	 * @param res
	 * @throws IOException
	 */
	private void responseEsborrarTrajecte(HttpServletResponse resp, int res)
			throws IOException {

		PrintWriter out = resp.getWriter();
		out.println(res);
	}

	/**
	 * Aquest mtode possibilita la publicaci d'un trajecte per part de l'usuari.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void publicarTrajecte(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		String origen = request.getParameter("origen");
		String destinacio = request.getParameter("destinacio");
		String data = request.getParameter("data");
		int hora = Integer.parseInt(request.getParameter("hora"));
		int minut = Integer.parseInt(request.getParameter("minut"));
		String model_cotxe = request.getParameter("model_cotxe");
		int places = Integer.parseInt(request.getParameter("places"));
		double preu = Double.parseDouble(request.getParameter("preu"));
		String mida_equipatge = request.getParameter("mida_equipatge");
		String e_mail = request.getParameter("e_mail");
		boolean permes_fumar = Boolean.parseBoolean(request.getParameter("permes_fumar"));
		boolean radio_mp3 = Boolean.parseBoolean(request.getParameter("radio_mp3"));
		Trajectes trajecte = new Trajectes(origen, destinacio, data, hora, minut, model_cotxe,
				places, preu, mida_equipatge, e_mail, permes_fumar, radio_mp3);
		AfegirTrajecte AfTraj = new AfegirTrajecte();
		int result = AfTraj.afegirTrajecte(trajecte);
		responseAfegirTrajecte(response, result);


	}

	/**
	 * Resposta a la petici d'afegir un trajecte. Retorna 0  1 depenent del resultat de l'operaci. 
	 * Un 1 si tot ha funcionat b o un 0 en cas contrari.
	 * @param resp
	 * @param res
	 * @throws IOException
	 */
	private void responseAfegirTrajecte(HttpServletResponse resp, int res)
			throws IOException {

		PrintWriter out = resp.getWriter();
		out.println(res);
	}

	/**
	 * Mitjanant aquest mtode s possible que l'usuari pugui modificar un trajecte que t publicat.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void modificarTrajecte(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException{

		int id = Integer.parseInt(request.getParameter("id"));
		String origen = request.getParameter("origen");
		String destinacio = request.getParameter("destinacio");
		String data = request.getParameter("data");
		int hora = Integer.parseInt(request.getParameter("hora"));
		int minut = Integer.parseInt(request.getParameter("minut"));
		String model_cotxe = request.getParameter("model_cotxe");
		int places = Integer.parseInt(request.getParameter("places"));
		double preu = Double.parseDouble(request.getParameter("preu"));
		String mida_equipatge = request.getParameter("mida_equipatge");
		String e_mail = request.getParameter("e_mail");
		boolean permes_fumar = Boolean.parseBoolean(request.getParameter("permes_fumar"));
		boolean radio_mp3 = Boolean.parseBoolean(request.getParameter("radio_mp3"));
		int distancia = Integer.parseInt(request.getParameter("distancia"));
		int temps = Integer.parseInt(request.getParameter("temps"));

		ModificarTrajecte modTraj = new ModificarTrajecte();
		int result = modTraj.modificarTrajecte(id, origen, destinacio, data, hora, minut, model_cotxe,
				places, preu, mida_equipatge, e_mail, permes_fumar, radio_mp3, distancia, temps);
		responseModificarTrajecte(response, result);


	}

	/**
	 * Resposta a la petici de modificar un trajecte. Retorna 0  1 depenent del resultat de l'operaci. 
	 * Un 1 si tot ha funcionat b o un 0 en cas contrari.
	 * @param resp
	 * @param res
	 * @throws IOException
	 */
	private void responseModificarTrajecte(HttpServletResponse resp, int res)
			throws IOException {

		PrintWriter out = resp.getWriter();
		out.println(res);
	}
	/**
	 * Mitjanant aquest mtode obtindrem com a resultat una llista
	 * de trajectes que coincideixin amb el que es cerca.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void cercarPunts(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException{
		System.out.println("Entra a mapa");
		ArrayList<Double> punts = new ArrayList<Double>();
		CercarPunts cp = new CercarPunts();

		String origen = request.getParameter("origen");
		String destinacio = request.getParameter("destinacio");

		punts = cp.cercarPunts(origen, destinacio);
		responseCercarPunts(response, punts);


	}
	/**
	 * Mitjanant aquest mtode, enviem a l'usuari la llista amb
	 * els punts que s'han trobat amb les caracterstiques de
	 * la cerca.
	 * @param resp
	 * @param llista
	 * @throws IOException
	 */
	private void responseCercarPunts(HttpServletResponse resp, ArrayList<Double> llista)
			throws IOException {

		JSONObject cadena = new JSONObject();
		cadena.put("usuari", llista);

		resp.setContentType("application/json");
		resp.setCharacterEncoding("UTF-8");
		PrintWriter out = resp.getWriter();
		out.println(cadena);
		System.out.println("Surt de mapa");
	}

	/**
	 * Mitjanant aquest mtode, obtindrem la informaci de 
	 * contacte per a formalitzar la reserva entre usuari i conductor.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void ferReserva(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException{

		String resultat="";

		String e_mail = request.getParameter("correu");
		Reserva reserva = new Reserva();
		resultat = reserva.cercaDadesUsuari(e_mail);

		responseFerReserva(response, resultat);


	}
	/**
	 * Amb aquest mtode, enviem les dades per a fer la reserva a
	 * l'usuari que les ha sollicitat.
	 * @param resp
	 * @param resultat
	 * @throws IOException
	 */
	private void responseFerReserva(HttpServletResponse resp, String resultat)
			throws IOException {

		//Enviem la resposta.
		PrintWriter out = resp.getWriter();
		out.println(resultat);
	}

	/**
	 * Mtode que permetr tornar els comentaris fets a un conductor.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void veureComentaris(HttpServletRequest request, HttpServletResponse response)throws ServletException, IOException{

		ArrayList <Comentari> comUser = new ArrayList<Comentari>();
		CercarComentaris cc = new CercarComentaris();
		String e_mail = request.getParameter("e_mail");
		comUser = cc.cercarComentaris(e_mail);

		responseVeureComentaris(response, comUser);

	}
	/**
	 * Amb aquest mtode enviem els comentaris trobats del conductor.
	 * @param resp
	 * @param llista
	 * @throws IOException
	 */
	private void responseVeureComentaris(HttpServletResponse resp, ArrayList<Comentari> llista)
			throws IOException {


		JSONObject cadena = new JSONObject();
		cadena.put("comentaris", llista);

		resp.setContentType("application/json");
		resp.setCharacterEncoding("UTF-8");
		PrintWriter out = resp.getWriter();
		out.println(cadena);
	}

	/**
	 * Mitjanant aquest mtode obtindrem com a resultat una llista
	 * amb els punts d'un trajecte.
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	private void cercarTrajecte(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException{

		List<Trajectes> trajectes = new ArrayList<Trajectes>();
		CercarTrajectes ct = new CercarTrajectes();

		String origen = request.getParameter("origen");
		String destinacio = request.getParameter("destinacio");
		String data = request.getParameter("data");

		trajectes = ct.cercar(origen, destinacio, data);
		responseCercarTrajecte(response, trajectes);


	}
	/**
	 * Mitjanant aquest mtode, enviem a l'usuari la llista amb
	 * els trajectes que s'han trobat amb les caracterstiques de
	 * la cerca.
	 * @param resp
	 * @param llista
	 * @throws IOException
	 */
	private void responseCercarTrajecte(HttpServletResponse resp, List<Trajectes> llista)
			throws IOException {

		JSONObject cadena = new JSONObject();
		cadena.put("usuari", llista);

		resp.setContentType("application/json");
		resp.setCharacterEncoding("UTF-8");
		PrintWriter out = resp.getWriter();
		out.println(cadena);
	}





































	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		if(request.getParameter("tasca").equals("registre")){
			registrarUsuari(request, response);

		}else if(request.getParameter("tasca").equals("publicar")){
			publicarTrajecte(request, response);
		}else if(request.getParameter("tasca").equals("modificar")){
			modificarTrajecte(request, response);
		}else if(request.getParameter("tasca").equals("comentari")){
			afegirComentari(request, response);
		}else if(request.getParameter("tasca").equals("mapa")){
			cercarPunts(request, response);
		}

	}

}
