package cat.pepweb.pep.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import cat.pepweb.pep.beans.Comentari;



public class OperacioAfegirUnComentari extends Connexio{

	private static final String CREAR_REGISTRE="INSERT INTO comentarisconductor (nom, cognoms, puntuacio," +
			" comentari, e_mail) VALUES (?,?,?,?,?);"; 
	private static final String CERCAR_COMENTARIS="SELECT * FROM comentarisconductor WHERE e_mail=?;";
	private PreparedStatement ps=null;


	/**
	 * Mtode per crear nous comentaris de usuaris a conductors a la
	 * base de dades.
	 * @param comentari
	 * @return
	 */
	public int crearComentari(Comentari comentari) {


		Connection con;
		con = obrirConnexio();
		int t = 0;
		try {

			ps = con.prepareStatement(CREAR_REGISTRE);
			ps.setString(1, comentari.getNom());
			ps.setString(2, comentari.getCognoms());
			ps.setInt(3, comentari.getPuntuacio());
			ps.setString(4, comentari.getComentari());
			ps.setString(5, comentari.getE_mail());
			t = ps.executeUpdate();
		} catch (SQLException e) {

			//e.printStackTrace();
		}
		tancarConnexio();

		return t;

	}

	/**
	 * Mtode que ens permet recuperar comentaris d'usuaris que han 
	 * fet a un determinat conductor.
	 * @param e_mail
	 * @return
	 */
	public ArrayList<Comentari> cercarComentaris(String e_mail) {

		Connection con;
		con = obrirConnexio();
		Comentari com[] = new Comentari[300];
		ArrayList <Comentari> lt = new ArrayList<Comentari>();
		int a = 0;
		try {
			ps = con.prepareStatement(CERCAR_COMENTARIS);
			ps.setString(1, e_mail);
			ResultSet rs = ps.executeQuery();
			while(rs.next()) {
				com[a] = new Comentari();

				com[a].setId(rs.getInt("id"));
				com[a].setNom(rs.getString("nom"));
				com[a].setCognoms(rs.getString("cognoms"));
				com[a].setPuntuacio(rs.getInt("puntuacio"));
				com[a].setComentari(rs.getString("comentari"));
				com[a].setE_mail(rs.getString("e_mail"));

				lt.add(com[a]);
				a = a+1;
			}
		}
		catch (SQLException e) {
			e.printStackTrace();
		}
		tancarConnexio();
		return lt;
	}

}
