package cat.pepweb.pep.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import cat.pepweb.pep.beans.Localitats;

public class OperacionsLocalitats extends Connexio{


	private static final String CREAR_REGISTRE="INSERT INTO localitats (nom, longitud, latitud)" +
			"VALUES (?,?,?);"; 
	private static final String LLEGIR_REGISTRE	="SELECT * FROM localitats WHERE nom=?;";
	private PreparedStatement ps=null;

	
	
	/**
	 * Mtode que ens permet guardar una nova instncia de la
	 * classe Localitats.
	 * @param localitat
	 * @return
	 */
	public int crearLocalitat(Localitats localitat) {

		Connection con;
		con = obrirConnexio();
		int t = 0;
		try {

			ps = con.prepareStatement(CREAR_REGISTRE);

			ps.setString(1,localitat.getNom());
			ps.setDouble(2,localitat.getLongitud());
			ps.setDouble(3, localitat.getLatitud());

			t = ps.executeUpdate();

		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		return t;
	}

		/**
		 * Mtode que ens permet recuperar la informaci o dades d'una
		 * localitat emmagatzemada a la base de dades.
		 * @param nom
		 * @return
		 */
	public Localitats llegirLocalitat(String nom) {

		Connection con;
		con = obrirConnexio();
		Localitats localitat = new Localitats();
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, nom);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				localitat.setNom(rs.getString("nom"));
				localitat.setLongitud(rs.getDouble("longitud"));
				localitat.setLatitud(rs.getDouble("latitud"));

			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		return localitat;
	}

}
