package cat.pepweb.pep.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import cat.pepweb.pep.beans.Puntdenopas;

public class OperacionsPuntsDeNoPas extends Connexio{

	private static final String CREAR_REGISTRE="INSERT INTO puntsdenopas (origen, destinacio, idruta)" +
			"VALUES (?,?,?);"; 
	private static final String LLEGIR_REGISTRE	="SELECT * FROM puntsdenopas WHERE origen=? AND destinacio=?" +
			"AND idruta=?;";
	private PreparedStatement ps=null;


	/**
	 * Mtode que crea un nou punt de pas d'una ruta a la taula.
	 * @param ruta
	 * @return
	 */
	public int crearRegistreRuta(Puntdenopas puntdenopas) {


		Connection con;
		con = obrirConnexio();
		int t = 0;
		try {

			ps = con.prepareStatement(CREAR_REGISTRE);
			ps.setString(1, puntdenopas.getOrigen());
			ps.setString(2, puntdenopas.getDestinacio());
			ps.setInt(3, puntdenopas.getIdRuta());

			t = ps.executeUpdate();
		} catch (SQLException e) {

			e.printStackTrace();
		}
		tancarConnexio();

		return t;

	}

	/**
	 * Mtode que retorna un punt de pas.
	 * @param origen
	 * @param destinacio
	 * @return
	 */
	public int llegirIDRuta(String origen, String destinacio, int id) {

		Connection con;
		con = obrirConnexio();
		Puntdenopas puntdenopas = new Puntdenopas();
		int idPuntdenopas = -1;
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, origen);
			ps.setString(2, destinacio);
			ps.setInt(3, id);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				puntdenopas.setId(rs.getInt("id"));
				idPuntdenopas = puntdenopas.getId();

			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();

		return idPuntdenopas;
	}

}
