package cat.pepweb.pep.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import cat.pepweb.pep.beans.Usuari;

public class OperacionsRegistreUsuari extends Connexio{

	private static final String CREAR_REGISTRE="INSERT INTO registre (nom, cognoms, e_mail, any_naixement," 
			+ "telefon, contrasenya, sexe, telefon_public, e_mail_public)"
			+ "VALUES(?,?,?,?,?,?,?,?,?);";
	private static final String LLEGIR_REGISTRE	="SELECT * FROM registre WHERE e_mail=?;";
	private static final String ACTUALITZAR_REGISTRE="UPDATE registre SET nom=?,cognoms=?,e_mail=?,any_naixement=?,telefon=?," +
			"contrasenya=?,sexe=?,telefon_public=?,e_mail_public=?;";
	private static final String ESBORRAR_REGISTRE="DELETE FROM registre WHERE e_mail=?;";
	//private static final String LLISTAR_REGISTRES="SELECT * FROM registre;";
	private PreparedStatement ps=null;

	/**
	 * Es genera un nou registre.
	 * @param usuari
	 * @return
	 */
	public int crearRegistreUsuari(Usuari usuari) {


		Connection con;
		con = obrirConnexio();
		int t = 0;
		try {

			ps = con.prepareStatement(CREAR_REGISTRE);
			ps.setString(1, usuari.getNom());
			ps.setString(2, usuari.getCognoms());
			ps.setString(3, usuari.getE_mail());
			ps.setInt(4, usuari.getAnyNaixement());
			ps.setString(5, usuari.getTelefon());
			ps.setString(6, usuari.getContrasenya());
			ps.setBoolean(7, usuari.isSexe());
			ps.setBoolean(8, usuari.isTelefonPublic());
			ps.setBoolean(9, usuari.isE_mailPublic());

			t = ps.executeUpdate();
		} catch (SQLException e) {

			//e.printStackTrace();
		}
		tancarConnexio();

		return t;

	}

	/**
	 * Es llegeixen les dades d'un usuari.
	 * @param e_mail
	 * @return
	 */

	public Usuari llegirRegistreUsuari(String e_mail) {

		Connection con;
		con = obrirConnexio();
		Usuari user = new Usuari();
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, e_mail);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				user.setNom(rs.getString("nom"));
				user.setCognoms(rs.getString("cognoms"));
				user.setE_mail(rs.getString("e_mail"));
				user.setAnyNaixement(rs.getInt("any_naixement"));
				user.setTelefon(rs.getString("telefon"));
				user.setContrasenya(rs.getString("contrasenya"));
				user.setSexe(rs.getBoolean("sexe"));
				user.setTelefonPublic(rs.getBoolean("telefon_public"));
				user.setE_mailPublic(rs.getBoolean("e_mail_public"));

			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		return user;
	}
	/**
	 * S'esborren les dades d'un usuari.
	 * @param e_mail
	 * @return
	 */
	public int esborrarRegistreUsuari(String e_mail) {

		Connection con;
		con = obrirConnexio();
		int t = 0;

		try {

			ps = con.prepareStatement(ESBORRAR_REGISTRE);
			ps.setString(1, e_mail);
			t = ps.executeUpdate();	
		}catch (SQLException e){
			e.printStackTrace();}
		tancarConnexio();

		return t;
	}
	/**
	 * S'actualitzen les dades d'un usuari.
	 * @param usuari
	 * @return
	 */
	public int actualitzarRegistre(Usuari usuari) {

		Connection con;
		con = obrirConnexio();
		int t=0;

		try {
			ps = con.prepareStatement(ACTUALITZAR_REGISTRE);
			ps.setString(1, usuari.getNom());
			ps.setString(2, usuari.getCognoms());
			ps.setString(3, usuari.getE_mail());
			ps.setInt(4, usuari.getAnyNaixement());
			ps.setString(5, usuari.getTelefon());
			ps.setString(6, usuari.getContrasenya());
			ps.setBoolean(7, usuari.isSexe());
			ps.setBoolean(8, usuari.isTelefonPublic());
			ps.setBoolean(9, usuari.isE_mailPublic());


			t=ps.executeUpdate();
		}catch (SQLException e) {
			e.printStackTrace();
		}
		tancarConnexio();
		return t;
	}

}
