package cat.pepweb.pep.jdbc;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import cat.pepweb.pep.beans.Ruta;

public class OperacionsRuta extends Connexio{

	private static final String CREAR_REGISTRE="INSERT INTO ruta (origen, destinacio, distancia, temps, " +
			"punts)VALUES (?,?,?,?,?);"; 
	private static final String LLEGIR_REGISTRE	="SELECT * FROM ruta WHERE origen=?" +
			"AND destinacio=?;";
	private PreparedStatement ps=null;


	public int crearRegistreRuta(Ruta ruta) {


		Connection con;
		con = obrirConnexio();
		int t = 0;
		try {

			ps = con.prepareStatement(CREAR_REGISTRE);
			ps.setString(1, ruta.getOrigen());
			ps.setString(2, ruta.getDestinacio());
			ps.setInt(3, ruta.getDistancia());
			ps.setInt(4, ruta.getTemps());
			ps.setString(5, ruta.getPunts());

			t = ps.executeUpdate();
		} catch (SQLException e) {

			e.printStackTrace();
		}
		tancarConnexio();

		return t;

	}


	/**
	 * Mtode que retorna una ruta segon origen i destinaci.
	 * @param origen
	 * @param destinacio
	 * @return
	 */
	public Ruta llegirRuta(String origen, String destinacio) {

		Connection con;
		con = obrirConnexio();
		Ruta ruta = new Ruta();
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, origen);
			ps.setString(2, destinacio);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				ruta.setId(rs.getInt("id"));
				ruta.setOrigen(rs.getString("origen"));
				ruta.setDestinacio(rs.getString("destinacio"));
				ruta.setDistancia(rs.getInt("distancia"));
				ruta.setTemps(rs.getInt("temps"));
				ruta.setPunts(rs.getString("punts"));
			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		return ruta;
	}

	/**
	 * Mtode que retorna l'id d'una ruta segons l'origen i destinaci.
	 * @param origen
	 * @param destinacio
	 * @return
	 */
	public int llegirIDRuta(String origen, String destinacio) {

		Connection con;
		con = obrirConnexio();
		Ruta ruta = new Ruta();
		int idRuta = 0;
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, origen);
			ps.setString(2, destinacio);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				ruta.setId(rs.getInt("id"));

			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		idRuta = ruta.getId();
		return idRuta;
	}

	/**
	 * Mtode que retorna els punts d'una ruta segons l'origen i destinaci.
	 * @param origen
	 * @param destinacio
	 * @return
	 */
	public String llegirPunts(String origen, String destinacio) {

		Connection con;
		con = obrirConnexio();
		Ruta ruta = new Ruta();
		String punts = "";
		try {

			ps = con.prepareStatement(LLEGIR_REGISTRE);
			ps.setString(1, origen);
			ps.setString(2, destinacio);
			ResultSet rs = ps.executeQuery();
			while(rs.next()){

				ruta.setPunts(rs.getString("punts"));

			}
		} catch (SQLException e) {
			e.printStackTrace();}
		tancarConnexio();
		punts = ruta.getPunts();
		return punts;
	}

}
