package cat.pepweb.pep.negoci;

import cat.pepweb.pep.beans.Comentari;
import cat.pepweb.pep.beans.Trajectes;
import cat.pepweb.pep.beans.Usuari;
import cat.pepweb.pep.jdbc.OperacioAfegirUnComentari;
import cat.pepweb.pep.jdbc.OperacionsRegistreUsuari;
import cat.pepweb.pep.jdbc.OperacionsTrajectesUsuari;

public class AfegirComentari {

	/**
	 * Mtode amb tota la lgica necessria per afegir un comentari
	 * a la base de dades.
	 * @param comentari
	 * @return
	 */
	public int afegirUnComentari(Comentari comentari){

		OperacioAfegirUnComentari opAfCom = new OperacioAfegirUnComentari();
		String nom;
		String cognoms;
		String e_mail = null;
		Comentari comentariFinal = new Comentari();
		Trajectes trajecte = new Trajectes();
		OperacionsTrajectesUsuari otu = new OperacionsTrajectesUsuari();
		OperacionsRegistreUsuari oru = new OperacionsRegistreUsuari();
		Usuari user = new Usuari();

		//Cerquem el trajecte del qual es fa el comentari.
		trajecte = otu.trobarTrajecte(comentari.getId());
		e_mail = trajecte.getE_mail();//S'extreu el correu.
		user = oru.llegirRegistreUsuari(e_mail);//S'en cerca l'usuari.
		nom = user.getNom();//S'en extreuent les dades.
		cognoms = user.getCognoms();
		//Es preparen les dades del comentari a guardar.
		comentariFinal.setNom(nom);
		comentariFinal.setCognoms(cognoms);
		comentariFinal.setPuntuacio(comentari.getPuntuacio());
		comentariFinal.setComentari(comentari.getComentari());
		comentariFinal.setE_mail(e_mail);

		int result = opAfCom.crearComentari(comentariFinal);
		if(result > 0){
			return 1;
		}

		return 0;
	}

}
