package cat.pepweb.pep.negoci;

import java.util.ArrayList;
import java.util.List;

import cat.pepweb.pep.beans.Localitats;
import cat.pepweb.pep.beans.Ruta;
import cat.pepweb.pep.beans.Trajectes;
import cat.pepweb.pep.jdbc.OperacionsLocalitats;
import cat.pepweb.pep.jdbc.OperacionsRuta;
import cat.pepweb.pep.jdbc.OperacionsTrajectesUsuari;
import cat.pepweb.pep.utilitats.CercarCoordenades;
import cat.pepweb.pep.utilitats.CercarRuta;

public class AfegirTrajecte {

	OperacionsTrajectesUsuari opTrajUsuari = new OperacionsTrajectesUsuari();
	Double latitudOrigen;
	Double longitudOrigen;
	Double latitudDestinacio;
	Double longitudDestinacio;
	int distancia;
	int temps;
	String punts;



	/**
	 * Mtode que ens emmagatzemar un nou trajecte publicat per un usuari. Si la ruta del trajecte
	 * no existeix, tamb la donar d'alta a la base de dades, si les coordenades dels punts d'origen
	 * i dest no existeixen, tamb els donar d'alta a la base de dades.
	 * @param trajecte
	 * @return
	 */

	public int afegirTrajecte(Trajectes trajecte){

		String origen = trajecte.getOrigen();
		String destinacio = trajecte.getDestinacio();
		OperacionsRuta opRuta = new OperacionsRuta();
		Ruta hiHaRuta;
		hiHaRuta = opRuta.llegirRuta(origen, destinacio);
		if(hiHaRuta != null){

		}
		//Emmagatzemem el trajecte si ja hi ha una ruta igual guardada.
		if(hiHaRuta.getDestinacio()!= null){

			trajecte.setDistancia(hiHaRuta.getDistancia());//Llegim la longitus de la ruta.
			trajecte.setTemps(hiHaRuta.getTemps());//Llegim el temps estimat de la ruta.		
			int result = opTrajUsuari.crearTrajecte(trajecte);
			if(result > 1){
				result = 1;
			}
			return result;
		}else{

			//Anem a cercar els punts, distncia i temps de la ruta. En primer lloc cerquem les
			//coordenades de l'origen i dest.

			cercarCoordenades(trajecte);

			//Amb aix ja tenim les variable globals de coordenades amb la informaci correcta.
			//Ara anem a cercar els punts de la ruta, la distncia i el temps estimat.

			cercarPuntsDistanciaTemps();
			//Extraiem el temps i la distncia de la llista.
			trajecte.setDistancia(distancia);
			trajecte.setTemps(temps);
			int result = opTrajUsuari.crearTrajecte(trajecte);
			if(result > 1){
				result = 1;
			}

			//Ara generem una  nova ruta i l'emmagatzemarem a la taula de rutes sempre i quan
			//tinguem els punts, dons podria ser que en alguna ocasi, no es trobs la ruta
			//i llavors,encara que el trajecte fos vlid, no tindria sentit emmagatzemar una
			//ruta buida.

			if(punts != null){
				Ruta ruta = new Ruta(trajecte.getOrigen(), trajecte.getDestinacio(), distancia, temps, punts);
				OperacionsRuta opR = new OperacionsRuta();
				int res = opR.crearRegistreRuta(ruta);

				if(result == 1 & res == 1){
					return 1;
				}else{
					return 0;
				}
			}
			return result;
		}		
	}
	/**
	 * Mtode que actualitza les variables globals corresponents a les coordenades dels punts origen
	 * i dest.
	 * @param trajecte
	 */
	public void cercarCoordenades(Trajectes trajecte){

		//En primer lloc mirarem si tenim les coordenades de l'origen i el dest.
		//Per aix mirarem si trobem el punt d'origen i el de dest a la taula localitats.

		OperacionsLocalitats opLocal = new OperacionsLocalitats();
		Localitats locOrigen = new Localitats();
		Localitats locDestinacio = new Localitats();
		locOrigen = opLocal.llegirLocalitat(trajecte.getOrigen());
		locDestinacio = opLocal.llegirLocalitat(trajecte.getDestinacio());

		//Si la localitat origen no s a la taula anem a cercar les seves coordenades a l'exterior.

		if((locOrigen.getNom())== null){

			CercarCoordenades cerCoor = new CercarCoordenades();
			List <Double> coordenades;
			coordenades = cerCoor.cercarCoordenadesLocalitat(trajecte.getOrigen());
			if(coordenades.size()>0){
				longitudOrigen = coordenades.get(0);
				latitudOrigen = coordenades.get(1);

				//Ara guardem aquesta nova localitat a la taula.
				locOrigen.setNom(trajecte.getOrigen());
				locOrigen.setLongitud(longitudOrigen);
				locOrigen.setLatitud(latitudOrigen);
				opLocal.crearLocalitat(locOrigen);
			}

		}else{

			latitudOrigen = locOrigen.getLatitud();
			longitudOrigen = locOrigen.getLongitud();

		}

		if((locDestinacio.getNom())== null){

			CercarCoordenades cerCoor = new CercarCoordenades();
			List <Double> coordenades;
			coordenades = cerCoor.cercarCoordenadesLocalitat(trajecte.getDestinacio());
			if(coordenades.size()>0){
				longitudDestinacio = coordenades.get(0);
				latitudDestinacio = coordenades.get(1);


				//Ara guardem aquesta nova localitat a la taula.

				locDestinacio.setNom(trajecte.getDestinacio());
				locDestinacio.setLongitud(longitudDestinacio);
				locDestinacio.setLatitud(latitudDestinacio);
				opLocal.crearLocalitat(locDestinacio);
			}

		}else{

			latitudDestinacio = locDestinacio.getLatitud();
			longitudDestinacio = locDestinacio.getLongitud();

		}

		//El que hem fet amb aquests dos if ltims ha estat anar a la taula localitats per veure
		//si trobem les coordenades de la localitat d'origen i de la de dest. Si no en trobem cap
		// o una, invoquem el mtode cercarCoordenadesLocalitat de la classe CercarCoordenades que
		//mitjanant una URL anir a cercar-les a l'exterior. Un cop ens les retorni, les introdum
		//a les variables i generem un nou objecte Localitats que l'emmagatzemem a la taula perqu
		//d'aquesta manera, ja tindrem les coordenades per una altre ocasi.



	}
	/**
	 * Mtode que actualitza les variables globals distncia, temps i punts. 
	 */
	public void cercarPuntsDistanciaTemps(){

		CercarRuta cercarRuta = new CercarRuta();
		List<String> puntsDistanciaTemps = new ArrayList<String>();

		puntsDistanciaTemps = cercarRuta.cercarRuta(latitudOrigen, longitudOrigen, 
				latitudDestinacio, longitudDestinacio);
		if(puntsDistanciaTemps.get(0)!=null && puntsDistanciaTemps.
				get(1) != null){
			distancia = Integer.parseInt(puntsDistanciaTemps.get(0));
			temps = Integer.parseInt(puntsDistanciaTemps.get(1));
			punts = puntsDistanciaTemps.get(2);
		}



	}

}
