package cat.pepweb.pep.negoci;

import java.util.ArrayList;
import java.util.List;

import cat.pepweb.pep.beans.Localitats;
import cat.pepweb.pep.beans.Puntdenopas;
import cat.pepweb.pep.beans.Puntdepas;
import cat.pepweb.pep.beans.Trajectes;
import cat.pepweb.pep.jdbc.OperacionsLocalitats;
import cat.pepweb.pep.jdbc.OperacionsPuntsDeNoPas;
import cat.pepweb.pep.jdbc.OperacionsPuntsDePas;
import cat.pepweb.pep.jdbc.OperacionsRuta;
import cat.pepweb.pep.jdbc.OperacionsTrajectesUsuari;
import cat.pepweb.pep.utilitats.CercarCoordenades;

public class CercarTrajectes {

	//Llista amb tots els trajectes.
	List<Trajectes> totsElsTrajectes = new ArrayList<Trajectes>();
	//Llista amb els trajectes vlids.
	List<Trajectes> trajectesBons = new ArrayList<Trajectes>();	
	//Llista amb  trajectes per eliminar.
	List<Integer> resteTrajectes1 = new ArrayList<Integer>();
	//Instanciem objecte de la classe OperacionsTrajectesUsuari per 
	//propsit general.
	OperacionsTrajectesUsuari opTrUs = new OperacionsTrajectesUsuari();
	OperacionsPuntsDePas opPuntsPas = new OperacionsPuntsDePas();
	OperacionsPuntsDeNoPas opPuntsNoPas = new OperacionsPuntsDeNoPas();
	Trajectes tr = new Trajectes();
	OperacionsRuta opRut = new OperacionsRuta();
	double longitudOrigen;
	double latitudOrigen;
	double longitudDestinacio;
	double latitudDestinacio;

	/**
	 * Mtode que retornar una llista amb els trajectes en els quals
	 * origen i destinaci corresponguin a aquests, de forma total o
	 * parcial.
	 * @param origen
	 * @param destinacio
	 * @param data
	 * @return
	 */

	public List<Trajectes>  cercar(String origen, String destinacio,
			String data){

		//Anem a cercar els trajectes.
		//Si no s'ha seleccionat data es retornen tots els trajectes
		//vlids sense tenir en compte la data.
		if(data == ""){
			
			totsElsTrajectes = opTrUs.llistarTrajectes();
		}else{

			totsElsTrajectes = opTrUs.llistarTrajectes(data);
		}


		//Mirem quins d'ells coincideix l'origen i la destinaci.


		for (int i = 0; i< totsElsTrajectes.size(); i++){

			tr = totsElsTrajectes.get(i);
			if((tr.getOrigen().equals(origen))&& (tr.getDestinacio().
					equals(destinacio))){
				trajectesBons.add(tr);
				resteTrajectes1.add(i);

			}

		}

		//Eliminem els trajectes que han canviat de llista.
		int comptador = resteTrajectes1.size();
		for(int i=0; i<resteTrajectes1.size(); i++){
			int a = resteTrajectes1.get(comptador -(i+1));
			totsElsTrajectes.remove(a);
		}
		resteTrajectes1.clear();//Deixem a zero la llista.

		//Mirem si aquesta ruta s punt de pas d'alguna d'elles o no.

		for(int i = 0; i< totsElsTrajectes.size(); i++){

			tr = totsElsTrajectes.get(i);
			String org = tr.getOrigen();
			String dst = tr.getDestinacio();
			int id = opRut.llegirIDRuta(org, dst);//cerquem l'id de ruta.
			int hoEs = opPuntsPas.llegirIDRuta(origen, destinacio, 
					id);//Mirem si s punt de pas
			if(hoEs != -1){//s punt de pas.

				trajectesBons.add(tr);
				resteTrajectes1.add(i);
				//System.out.println("esPuntDePas");

			}else{//Si no s punt de pas mirem si podem assegurar que no ho s.

				hoEs = opPuntsNoPas.llegirIDRuta(origen, destinacio, id);
				if(hoEs != -1){//Si l'hem trobat no s punt de pas de la ruta.
					resteTrajectes1.add(i);
					//System.out.println("esPuntDeNoPas");

				}

			}
		}

		//Eliminem els trajectes que han canviat de llista.

		int compt = resteTrajectes1.size();
		for(int i=0; i<compt; i++){
			int a = resteTrajectes1.get(compt -(i+1));
			totsElsTrajectes.remove(a);	 
		}
		resteTrajectes1.clear();//Deixem a zero la llista.


		//Ara, amb les rutes que queden, mirarem si el trajecte
		//sollicitat cau dintre d'alguna ruta, comparant els punts.


		int total = totsElsTrajectes.size();
		if(total!= 0){//Cerquem les coordenades.
			cercarCoordenades(origen, destinacio);

			ArrayList<Double> punts;//Punts d'un trajecte.
			boolean inclosa = false;//Trobem la subruta.
			ArrayList<Integer> idInc = new ArrayList<Integer>();
			ArrayList<Integer> idNoInc = new ArrayList<Integer>();

			for(int i = 0; i<total; i++){

				tr = totsElsTrajectes.get(i);
				String org = tr.getOrigen();
				String dst = tr.getDestinacio();
				punts = cercarPunts(org, dst);
				int id = opRut.llegirIDRuta(org, dst);
				boolean rep = false;
				inclosa = esSubruta(punts);
				if(inclosa){//Inclom la subruta com a punts de pas de la ruta.
					for(int ind=0;ind<idInc.size();ind++){
						int idR = idInc.get(ind);
						if(idR == id){//Comprovem que ja no s'hagi donat d'alta.
							rep = true;
						}
					}
					if(rep == false){
						Puntdepas pPas = new Puntdepas(origen, destinacio,id);
						opPuntsPas.crearRegistreRuta(pPas);
						trajectesBons.add(tr);//Afegim trajecta trobat.
						idInc.add(id);
					}

					rep = false;


				}else{//Inclom la subruta com a punt de no pas per la ruta.

					for(int ind=0;ind<idNoInc.size();ind++){
						int idR = idNoInc.get(ind);
						if(idR == id){//Comprovem que ja no s'hagi donat d'alta.
							rep = true;
						}
					}


					if(id != 0 && rep == false){//Si s 0 no hi ha ruta.
						Puntdenopas pNP = new Puntdenopas(origen, destinacio, id);
						opPuntsNoPas.crearRegistreRuta(pNP);
						idNoInc.add(id);
						
					}

					rep = false;
				}
			}
		}
		//System.out.println(totsElsTrajectes.size()+ " " + trajectesBons.size());		
		return trajectesBons;

	}

	/**
	 * Mtode que actualitza les variables globals corresponents a les coordenades dels punts origen
	 * i dest.
	 * @param trajecte
	 */
	public void cercarCoordenades(String origen, String destinacio){

		//En primer lloc mirarem si tenim les coordenades de l'origen i el dest.
		//Per aix mirarem si trobem el punt d'origen i el de dest a la taula localitats.

		OperacionsLocalitats opLocal = new OperacionsLocalitats();
		Localitats locOrigen = new Localitats();
		Localitats locDestinacio = new Localitats();
		locOrigen = opLocal.llegirLocalitat(origen);
		locDestinacio = opLocal.llegirLocalitat(destinacio);

		//Si la localitat origen no s a la taula anem a cercar les seves coordenades a l'exterior.

		if((locOrigen.getNom())== null){

			CercarCoordenades cerCoor = new CercarCoordenades();
			List <Double> coordenades;
			coordenades = cerCoor.cercarCoordenadesLocalitat(origen);
			if(coordenades.size()>0){
				longitudOrigen = coordenades.get(0);
				latitudOrigen = coordenades.get(1);

				//Ara guardem aquesta nova localitat a la taula.
				locOrigen.setNom(origen);
				locOrigen.setLongitud(longitudOrigen);
				locOrigen.setLatitud(latitudOrigen);
				opLocal.crearLocalitat(locOrigen);
			}

		}else{

			latitudOrigen = locOrigen.getLatitud();
			longitudOrigen = locOrigen.getLongitud();

		}

		if((locDestinacio.getNom())== null){

			CercarCoordenades cerCoor = new CercarCoordenades();
			List <Double> coordenades;
			coordenades = cerCoor.cercarCoordenadesLocalitat(destinacio);
			if(coordenades.size()>0){
				longitudDestinacio = coordenades.get(0);
				latitudDestinacio = coordenades.get(1);


				//Ara guardem aquesta nova localitat a la taula.

				locDestinacio.setNom(destinacio);
				locDestinacio.setLongitud(longitudDestinacio);
				locDestinacio.setLatitud(latitudDestinacio);
				opLocal.crearLocalitat(locDestinacio);
			}

		}else{

			latitudDestinacio = locDestinacio.getLatitud();
			longitudDestinacio = locDestinacio.getLongitud();

		}

		//El que hem fet amb aquests dos if ltims ha estat anar a la taula localitats per veure
		//si trobem les coordenades de la localitat d'origen i de la de dest. Si no en trobem cap
		// o una, invoquem el mtode cercarCoordenadesLocalitat de la classe CercarCoordenades que
		//mitjanant una URL anir a cercar-les a l'exterior. Un cop ens les retorni, les introdum
		//a les variables i generem un nou objecte Localitats que l'emmagatzemem a la taula perqu
		//d'aquesta manera, ja tindrem les coordenades per una altre ocasi.



	}

	/**
	 * Mtode que retorna la llista de punts d'una ruta com a double.
	 * @param origen
	 * @param destinacio
	 * @return
	 */
	public ArrayList<Double> cercarPunts(String origen, String destinacio){

		ArrayList <Double> punts = new ArrayList<Double>();
		String puntsRuta="";
		String[] punts2;
		puntsRuta = opRut.llegirPunts(origen, destinacio);
		//System.out.println(puntsRuta);
		if((puntsRuta !=null)){//Si el trajecte no t ruta perqu no s'ha trobat.
			punts2 = puntsRuta.split(",");
			for(int i = 0; i<punts2.length; i++){
				punts.add(Double.valueOf(punts2[i]));
			}
		}

		return punts;
	}

	/**
	 * Mtode que torna true si dos punts pertanyen a una determinada
	 * ruta en un determinat ordre.
	 * @param punts
	 * @return
	 */
	private boolean esSubruta(ArrayList<Double> punts){

		double lon;
		double lat;
		double result;
		double tolerancia1 = 0.045;
		double tolerancia2 = -0.045;
		double tolLongOrig1;
		double tolLongOrig2;
		double tolLongDest1;
		double tolLongDest2;
		boolean origen = false;
		boolean destinacio = false;
		boolean esSubruta = false;
		int puntsTotalsOrigen = 0;
		int puntsTotalsDestinacio = 0;


		//Les tolerncies per les quals considerem que un punt cau dintre
		//de la ruta s d'aproximadament 5 km. Aquesta distncia en
		//milligraus, varia amb la latitud. Llavors la calcularem per a
		//cada latitud. Simplificant, la frmula trobada s la segent:
		//450/ cosx * 10018.5389. Hem pres el radi de la terra 6378km.
		//Tot plegat s una aproximaci ja que no cal que sigui exacte.

		//Passem els graus a radiants.

		double radOrigen = latitudOrigen  * 2.0 * (Math.PI / 360);
		double radDestinacio = latitudDestinacio * 2.0 * (Math.PI / 360);

		tolLongOrig1 = (450/((Math.cos(radOrigen))*10018.5389));
		tolLongOrig2 = tolLongOrig1 * -1;
		tolLongDest1 = (450/((Math.cos(radDestinacio))*10018.5389));
		tolLongDest2 = tolLongDest1 * -1;

		//Comencem a comprovar si algun punt de la ruta coincideix 
		//amb el d'origen i si s aix, farem el mateix amb el de
		//destinaci. Amb aix sabrem si la ruta passa per aquests
		//dos punts. Tamb comprovem el nmero total de punts des
		//del inici de la ruta a l'origen de la que cerquem i el 
		//mateix amb el punt de destinaci per tal de discriminar
		//possibles rutes iguals per de sentit contrari.

		for(int i=0; i<punts.size(); i= i+2){

			if(origen == false){
				lat = punts.get(i);
				result = lat - latitudOrigen;

				if(result <= tolerancia1 && result >= tolerancia2){
					lon = punts.get(i+1);
					result = lon - longitudOrigen;
					if(result <= tolLongOrig1 && result >= tolLongOrig2){
						origen = true;
						puntsTotalsOrigen = i;
						i = 0;

					}	
				}
			}else{

				lat = punts.get(i);
				result = lat - latitudDestinacio;

				if(result <= tolerancia1 && result >= tolerancia2){
					lon = punts.get(i+1);
					result = lon - longitudDestinacio;
					if(result <= tolLongDest1 && result >= tolLongDest2){
						destinacio = true;
						puntsTotalsDestinacio = i;
					}	
				}	

			}

			if (origen == true && destinacio == true){
				//Comprovem sentit vlid de la ruta.
				if(puntsTotalsDestinacio > puntsTotalsOrigen){
					esSubruta = true;
				}
				i = punts.size();//Finalitzem el bucle.
			}

		}
		//System.out.println(esSubruta + " " + tolLongOrig1 + " " + tolLongOrig2+
		//		" " + tolLongDest1 + " " + tolLongDest2);
		return esSubruta;

	}

}
