package cat.pepweb.pep.utilitats;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONObject;


public class CercarCoordenades {

	/**
	 * Mtode que ens retornar les coordenades d'una localitat. Per aix es fa s d'una URL externa
	 * que ens les subministra, passant com a parmetre el nom de la localitat.
	 * @param localitat
	 * @return
	 */
	public List<Double>  cercarCoordenadesLocalitat(String localitat){

		List<Double> coordenades = new ArrayList<Double>();
		String localitatFormatada = "";
		Double latitud = 1000.0;
		Double longitud = 1000.0;

		//Substitum els possibles espais en blanc que pugui tenir la localitat per %20.
		for (int x=0; x < localitat.length(); x++) {
			if (localitat.charAt(x) != ' '){
				localitatFormatada += localitat.charAt(x);
			}else{
				localitatFormatada += "%20";
			}	
		}
		//Formem la URL amb la consulta.
		String url = "http://nominatim.openstreetmap.org/search?q=" + localitatFormatada +"&limit=1&format=json";

		//Recuperem les coordenades de la localitat.
		try{
			URL miUrl = new URL(url);
			URLConnection miUrlCon = miUrl.openConnection(); 

			BufferedReader br = new BufferedReader(new InputStreamReader(miUrlCon.getInputStream())); 
			String str; 
			str = br.readLine();
			String cadenaFormatada = str.substring(1);
			JSONObject json = new JSONObject(cadenaFormatada);
			latitud = (Double)json.getDouble("lat");
			longitud = (Double)json.getDouble("lon");

		}catch(Exception e){
			System.out.println(e);
		}
		if(latitud != 1000.0){ //Mirem que realment s'han trobat les coordenades.
			coordenades.add(longitud);
			coordenades.add(latitud);
		}

		return coordenades;
	}

}
