package cat.pepweb.pep.utilitats;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class CercarRuta {

	/**
	 * Mtode mitjanant el qual, donades unes coordenades de punt d'origen i unes altres de punt
	 * destinaci, ens retornar una llista amb tres String: un amb la distncia de la ruta, un altre
	 * amb el temps estimat per fer-la (amb cotxe) i laltre tots els punts de la ruta. Fem s dels
	 * serveis que ens proporciona una web externa mitjanant una URL.
	 * @param latitudOrigen
	 * @param longitudOrigen
	 * @param latitudDestinacio
	 * @param longitudDestinacio
	 * @return
	 */

	public List<String> cercarRuta(Double latitudOrigen, Double longitudOrigen, Double latitudDestinacio,
			Double longitudDestinacio){

		List<String> resultat = new ArrayList<String>(); //Llista amb els resultats: distncia, temps, punts.
		String latOrig = String.valueOf(latitudOrigen); //Pasem els doubles a String per compondre l'adrea.
		String lonOrig = String.valueOf(longitudOrigen);
		String latDest = String.valueOf(latitudDestinacio);
		String lonDest = String.valueOf(longitudDestinacio);
		String origenDestinacio = latOrig +"," + lonOrig + "," + latDest + "," + lonDest;
		String result = null;

		String adreUrl = "http://routes.cloudmade.com/8ee2a50541944fb9bcedded5165f09d9/api/0.3/" +
				origenDestinacio + "/car/shortest.js?units=miles&lang=es";

		//Anem a cercar els punts de la ruta, la distncia i el temps.
		try {
			// Obrim la connexi

			URL url = new URL(adreUrl);
			URLConnection conexion = url.openConnection();
			conexion.connect();

			// Lectura
			InputStream is = conexion.getInputStream();

			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			result = br.readLine();

		} catch (MalformedURLException e) {

			e.printStackTrace();
		} catch (IOException e) {

			e.printStackTrace();
		}

		//Extraurem ara, la distncia, el temps i els punts del objecte Json que ens arriba del web.

		String distancia = null;
		String temps = null;

		JSONObject ruta = null;
		JSONArray punts = new JSONArray();

		try{

			JSONObject json = new JSONObject(result);
			ruta = json.getJSONObject("route_summary");
			distancia = String.valueOf(ruta.getInt("total_distance"));
			temps = String.valueOf(ruta.getInt("total_time"));
			punts = json.getJSONArray("route_geometry");

		}catch(JSONException e){
			System.out.println(e);
		}
		//Convertim els punts en un String on cada punt estar separat per comes.

		Double a;
		Double b;
		String cadenaPunts = "";

		for(int i=0; i<punts.length();i++){
			if(i < punts.length() -1){
				a = punts.getJSONArray(i).getDouble(0);
				b = punts.getJSONArray(i).getDouble(1);
				cadenaPunts = cadenaPunts + a + "," + b + ",";
			}else{
				a = punts.getJSONArray(i).getDouble(0);
				b = punts.getJSONArray(i).getDouble(1);
				cadenaPunts = cadenaPunts + a + "," + b;
			}
		}

		//Afegim els resultats a la llista que retornem.
		resultat.add(distancia);
		resultat.add(temps);
		resultat.add(cadenaPunts);


		return resultat;
	}

}
